# Elno Database Functions
#
# version
#  1.00  basic DB Functions
#  1.21  use print function

import mysql.connector as MySQLdb
import os
import sys
from utilities import set_prefix,printm
from dotenv import load_dotenv

dbversion = 1.23
dotenv_loaded = 0

def read_dotenv():
    global db_host,db_database,db_user,db_password,dotenv_loaded

    # Load environment variables from .env file
    #DB_HOST=localhost
    #DB_DATABASE=xxxxxx
    #DB_USERNAME=xxxxxxx
    #DB_PASSWORD=xxxxxxx

    old = os.path.dirname(__file__)
    new ='/var/www/'

    dotenv_path = os.path.join(new, 'html', '.env')
    load_dotenv(dotenv_path)
    # Access environment variables
    db_host = os.getenv('DB_HOST')
    db_database = os.getenv('DB_DATABASE')
    db_user = os.getenv('DB_USERNAME')
    db_password = os.getenv('DB_PASSWORD')

    printm(f"Database URL: {db_host}")
    printm(f"Database: {db_database}")
    printm(f"User : {db_user}")
    dotenv_loaded = 1
    printm("-- .env -- loaded")


def dbusers(cnx):
    printm('Skipping dbusers(cnx) : Function now VOID ')
    # printm('dbusers: Add User')
    # result = os.system("echo \"create user 'gateway'@'localhost' identified by '';\" |sudo mysql")
    # printm('dbusers: Grant User access to db Monitor')
    # result = os.system("echo \"grant all privileges on monitor.* to 'gateway'@'localhost';flush privileges;\" |sudo mysql")

#    rowraw = dbsql(cnx,"create user 'gateway'@'localhost' identified by ''; grant all privileges on monitor.* to 'gateway'@'localhost';flush privileges;")

def dbopeninit():
    global db_host,db_database,db_user,db_password,dotenv_loaded
#    set_prefix("dbfunctions: ")
    if dbopen():
        if dotenv_loaded == 0:
            read_dotenv()
        #printm('dbopen: Connected to database Server 1')
        cnx = MySQLdb.connect(host=db_host,user=db_user,password=db_password)
        cursor = cnx.cursor()
        cursor.execute("show Databases like 'monitor'")
        row = cursor.fetchone()
        cnx.close()
        if row:
            printm('dbopen: dB monitor exists ')
            return
        #     cursor.execute("select user from mysql.user where user like 'gateway'")
        #     row = cursor.fetchone()
        #     if row:
        #         #printm('dbopen: monitor dB user exists ')
        #         return dbopen()
        #     else:
        #         printm( 'dbopen: Missing User Account')
        #         dbusers(cnx)
        #         return dbopen()
        # else:
        #     printm( 'dbopen: Missing database monitor')
        #     cursor.execute("create Database monitor")
        #     cursor.execute("select user from mysql.user where user like 'gateway'")
        #     row = cursor.fetchone()
        #     if row:
        #         printm( 'dbopen: monitor dB user exists ')
        #         return dbopen()
        #     else:
        #         printm( 'dbopen: Create User Account')
        #         dbusers(cnx)
        #         return dbopen()
    else:
	    printm( 'dbopen: Failed to connect to dB Server, game over')
    sys.exit()          # Shutdown failure

def dbopen():
    global db_host,db_database,db_user,db_password,dotenv_loaded
    if dotenv_loaded == 0:
        read_dotenv()
    # this will fail if user not created
    return MySQLdb.connect(host=db_host,user=db_user,password=db_password,database=db_database)
#
# mysqli_real_escape_string(connection, escapestring)
#
def write_control_n(cnx,Control,Cnumber):
    cnx = dbopen()
    cursor = cnx.cursor()
    cursor.execute("update control set Cnumber = %s where Control = %s",(Cnumber,Control))
    cnx.commit()
    cnx.close()

def write_control_t(cnx,Control,Ctext):
    cnx = dbopen()
    cursor = cnx.cursor()
    cursor.execute("update control set Ctext = %s where Control = %s",(Ctext,Control))
    cnx.commit()
    cnx.close()

def write_control(cnx,Control,Cnumber,Ctext):
    cnx = dbopen()
    cursor = cnx.cursor()
    cursor.execute("update control set Cnumber = %s, Ctext = %s where Control = %s",(Cnumber,Ctext,Control))
    cnx.commit()
    cnx.close()

def read_control(cnx,Control):
    cnx = dbopen()
    cursor = cnx.cursor()
    cursor.execute("select * from control  where Control = %s",(Control,))
#    cnx.commit()
    row = cursor.fetchone()
    cnx.close()
    return row


def valid_control(cnx,Control):
    cnx = dbopen()
    cursor = cnx.cursor()
    cursor.execute("select * from control  where Control = %s",(Control,))
    results = cursor.fetchall()
    if cursor.rowcount == 0:
        cnx.close()
        return False
    else:
        cnx.close()
        return True

def dbsql2(type,sql):
    cnx = dbopen()
    cursor = cnx.cursor()
    cursor.execute(sql)
    if type == 1:
        record = cursor.fetchall()
    else:
        record = cursor.fetchone()
#    cnx.commit()
    cnx.close()
    return record

def dbsql(cnx,sql):
    cnx = dbopen()
    cursor = cnx.cursor()
    cursor.execute(sql)
#    cnx.commit()
    cnx.close()
    return cursor

def dbsqlw(cnx,sql):
    cnx = dbopen()
    cursor = cnx.cursor()
    cursor.execute(sql)
    cnx.commit()
    cnx.close()
    return cursor

def dbsqlblock(cnx,sql,darray):
    cnx = dbopen()
    cursor = cnx.cursor()
    cursor.execute(sql,darray)
    cnx.commit()
    cnx.close()
    return cursor

# Function to check if a column exists
def column_exists(cursor,table_name, column_name):
    query = f"SHOW COLUMNS FROM {table_name} LIKE '{column_name}'"
    cursor.execute(query)
    result = cursor.fetchone()
    return result is not None

def add_column_if_missing(table_name, column_name, column_definition):
    cnx = dbopen()
    cursor = cnx.cursor()
    if not column_exists(cursor,table_name, column_name):
        query = f"ALTER TABLE {table_name} ADD COLUMN {column_name} {column_definition}"
        cursor.execute(query)
        cnx.commit()
        printm(f"Column '{column_name}' added to table '{table_name}'")

    cnx.close
