import time
from datetime import date, datetime, timedelta
import pytz
from dbfunctions import dbopen,write_control_n,write_control_t,write_control,read_control,dbsql,dbsqlw,dbopeninit,dbsql2
from utilities import getgwid, set_prefix, printm, init_tmp2
import gw2mqttsend as mqttsend
import json
import RPi.GPIO as GPIO

currentlogdow = 0
healthevent = 0
healthupdate = 0
healthtime = 0
loghealthcheck = 0
last_cmdstart = ""
last_cmdversion= ""
last_cmdstatus = ""
last_sendstart = ""
last_sendversion= ""
last_sendstatus = ""
last_wtstart = ""
last_wtversion= ""
last_wtstatus = ""
last_hcstart = ""
last_hcversion= ""
last_hcstatus = ""
last_ledstart = ""
last_ledversion= ""
last_ledstatus = ""
last_tpcpu = "0"
last_tpgpu= "0"
last_tpstatus = ""
last_lbcount = ""
last_lbrestart= ""
last_lbstatus = ""

def resetRFreceiver(rfrset_count):
    GPIO.setwarnings(False)
    GPIO.setmode(GPIO.BCM)

    GPIO.setup(18,GPIO.OUT)   # old gateway reset
    GPIO.setup(4,GPIO.OUT)    # Reset built into IoT Hat

    # Reset pin 12 GPIO 18
    printm("Resetting RF Receiver")
    GPIO.output(18,False)
    time.sleep(.25)
    GPIO.output(18,True)
    #
    GPIO.output(4,False)
    time.sleep(.25)
    GPIO.output(4,True)
    time.sleep(3)           #allow for restart
    #
    local_timezone = pytz.timezone('GMT')  # Adjust to your local timezone
    local_time = datetime.now(local_timezone)
    write_control(0, 'RFResetCount', rfrset_count,local_time.strftime("%m/%d/%Y %H:%M:%S"))

def CheckHealth(logcheck):
    global healthtime,healthupdate,healthevent,loghealthcheck,healthpass1,last_cmdstart,last_cmdversion,last_cmdstatus,last_sendstart,last_sendversion,last_sendstatus\
    ,last_wtstart,last_wtversion,last_wtstatus,last_hcstart,last_hcversion,last_hcstatus,last_ledstart,last_ledversion,last_ledstatus\
    ,last_tpcpu,last_tpgpu,last_tpstatus,last_lbcount,last_lbrestart,last_lbstatus

    # Update MQTT if change in system Health
    # Update MQTT every xxx seconds
    loghealthcheck = logcheck
    printm("check health")
    led_status = appstate("gw2led.py")
    cmd_status = appstate("gw2cmd.py")
    send_status = appstate("gw2send.py")
    cmd_wr = appstate("gw2wireless.py")
    cmd_hc = appstate("gw2healthcheck.py")

    if led_status == 'Down' or cmd_status == 'Down' or send_status == 'Down' or cmd_wr == 'Down' or cmd_hc == 'Down':
        healthevent = 1
    else:
        healthevent = 0

    printm("Count till send at ",healthtime)
    #printm("healthupdate is ",healthupdate)
    if healthtime == 0 or healthevent == 1:
        if healthupdate == 0:
            healthupdate = 1    # Message has been sent
            # Send Health mqtt messages
            printm("Checking for change in Health")
            srecord = read_control(0,"CmdStart")
            vrecord = read_control(0,"CmdVersion")
            if last_cmdstart != srecord[3] or last_cmdversion != vrecord[3] or last_cmdstatus != cmd_status:
                sendmqtt_health("Cmd",vrecord[3],srecord[3],cmd_status)
                last_cmdstart = srecord[3]
                last_cmdversion= vrecord[3]
                last_cmdstatus = cmd_status
            srecord = read_control(0,"SendStart")
            vrecord = read_control(0,"SendVersion")
            if last_sendstart != srecord[3] or last_sendversion != vrecord[3] or last_sendstatus != cmd_status:
                sendmqtt_health("Sender",vrecord[3],srecord[3],send_status)
                last_sendstart = srecord[3]
                last_sendversion= vrecord[3]
                last_sendstatus = cmd_status
            srecord = read_control(0,"WTStart")
            vrecord = read_control(0,"WTVersion")
            if last_wtstart != srecord[3] or last_wtversion != vrecord[3] or last_wtstatus != cmd_status:
                sendmqtt_health("Receiver",vrecord[3],srecord[3],cmd_wr)
                last_wtstart = srecord[3]
                last_wtversion= vrecord[3]
                last_wtstatus = cmd_status

            srecord = read_control(0,"HCPID")
            vrecord = read_control(0,"HCVersion")
            if last_hcstart != srecord[3] or last_hcversion != vrecord[3] or last_hcstatus != cmd_status:
                sendmqtt_health("HealthCheck",vrecord[3],srecord[3],cmd_hc)
                last_hcstart = srecord[3]
                last_hcversion= vrecord[3]
                last_hcstatus = cmd_status

            srecord = read_control(0,"LEDStart")
            vrecord = read_control(0,"LEDVersion")
            if last_ledstart != srecord[3] or last_ledversion != vrecord[3] or last_ledstatus != cmd_status:
                sendmqtt_health("StatusLights",vrecord[3],srecord[3],led_status)
                last_ledstart = srecord[3]
                last_ledversion= vrecord[3]
                last_ledstatus = cmd_status

            srecord = read_control(0,"CPUTemp")
            vrecord = read_control(0,"GPUTemp")
            cmd_temp = "OK"
            if float(vrecord[3]) > 166.0 or float(srecord[3]) > 166.0:
                cmd_temp ="Hot"

            if abs(float(last_tpcpu) - float(srecord[3])) > 10 or abs(float(last_tpgpu) - float(vrecord[3])) > 10 or last_tpstatus != cmd_temp:
                sendmqtt_health("Temperature",vrecord[3],srecord[3],cmd_temp)
                last_tpcpu = srecord[3]
                last_tpgpu= vrecord[3]
                last_tpstatus = cmd_temp
            else:
                last_tpcpu = srecord[3]
                last_tpgpu= vrecord[3]

            sql = "select sum(count) from sensorlist;"
            results = dbsql2(0,sql)
            #printm(results)
            if results[0] :
                #printm("d ",str(results[0]))
                intresult = results[0]
            else:
                intresult = 0

            rxcountr = read_control(0,"RFCount")
            rxcount = rxcountr[2]
            lbstatus = "Working"

            NowTest = datetime.now()
            rowt = read_control(0,"LastSendSend")
            format_string = "%m/%d/%Y %H:%M:%S"
            lastsend = datetime.strptime(rowt[3], format_string)
            time_difference = NowTest - lastsend

            # If more than 5 minutes and no data sent, Error
            seconds = time_difference.seconds
            minutes = (seconds % 3600) // 60

            if rxcount == intresult and minutes > 5:
                lbstatus = "Issue"
            else:
                write_control_n(0,"RFCount",intresult)

            if rxcount == intresult and minutes > 30:      # It was working 30 minutes ago,it could be hung up, reset and clear
                printm("RX Count Stopped at ",intresult, "Clearing the Sensor List")
                sql = "delete from sensorlist where id > 0"
                results = dbsql2(0,sql)
                rxcountr = read_control(0,"RFResetCount")
                rfrset_count = rxcountr[2]
                resetRFreceiver(rfrset_count)

            rowr = read_control(0,"RFResetCount")
            if last_lbrestart != rowr[3] or last_lbstatus != lbstatus:
                sendmqtt_health("LifeByte",str(intresult),rowr[3],lbstatus)
                last_lbcount = intresult
                last_lbrestart= rowr[3]
                last_lbstatus = lbstatus


        healthevent = 0
        srecord = read_control(0,"StatusInterval")
        healthtime = srecord[2]          # send every 2.5 minutes
    else:
        healthtime -= 1
        healthupdate = 0

def mqtt_send_status(log_payload,app,payload):
    global currentlogdow
    healthpayload = json.dumps(log_payload)
    #printm(healthpayload)
    healthevent = app
    logtime =  time.localtime()
    logdayofweek = logtime.tm_wday
    dstart = time
    Start =dstart.strftime("%m/%d/%Y %H:%M:%S")
    if currentlogdow == logdayofweek:
        logfilename = f"/home/pi/gw2/errorhealthcheck{logdayofweek}.txt"
        printm("Same Log day")
    else:
        currentlogdow = logdayofweek
        logfilename = f"/home/pi/gw2/errorhealthcheck{logdayofweek}.txt"
        with open(logfilename,"w") as logfile:
            logfile.write("-----{} ------\n".format(Start))

    #if loghealthcheck == 1:
    logmessage = "{}: {} = {} \n".format(Start,app,healthpayload)
    with open(logfilename,"a") as logfile:
        logfile.write(logmessage)
    #else:
    cktime = time
    cktime = cktime.strftime("%Y/%m/%d %H:%M:%S")
    dt_utc = datetime.strptime(cktime, "%Y/%m/%d %H:%M:%S")

    # Set timezone to UTC
    utc_timezone = pytz.timezone("UTC")

    # Localize the datetime object to UTC
    dt_utc = utc_timezone.localize(dt_utc)

    # Convert datetime object to Eastern Time
    timezone = read_control(0,"Timezone")
    timezone = timezone[3]

    eastern_timezone = pytz.timezone("US/Eastern")
    dt_eastern = dt_utc.astimezone(eastern_timezone)

    # Format the datetime object as a string
    rxtime = dt_eastern.strftime("%Y/%m/%d %H:%M:%S")
    #printm(f'ready to send {payload} with date of {rxtime}')
    mqttsend.send_mqtt(payload, 1,1,rxtime,healthevent)


def sendmqtt_health(app,version,started,status):
    global healthtime,healthupdate,healthevent,loghealthcheck
    # "sensors":[ { "sensor":"83-54","value":"-68.0"}]}
    # sdata  = return [sensor_id,sensor_code,sensor_value,device_type,device_units]
    '''send: sdata  = ['96-14', 'BATT', '2.7', 'Voltage', 'V']

            sensor_id = mqtt_send[0]      app
            sensor_code = mqtt_send[1]    Status
            sensor_value = mqtt_send[2]   version started status
            sensor_type = mqtt_send[3]    Status
            sensor_unit = mqtt_send[4]    float, datetime, boolean
            app = temp
            sensor_id =    app
            sensor_code =  TEMP Status
            sensor_value = version started status
            sensor_type =  temp,temp, status
            sensor_unit =  C, C, boolean
            app = lifebyte
            sensor_id =    app
            sensor_code =  Count,Time,Status
            sensor_value = version,started,Status
            sensor_type =  Count,Time,Status
            sensor_unit =  int, datetime, boolean
    '''
    if app == "Temperature":
        log_payload = {"CPU":version,"Units_of_Measure":"Temperature"}
        payload = [app,"CPU",version,"CPU","F"]
        mqtt_send_status(log_payload,app,payload)
        log_payload = {"GPU":started,"Units_of_Measure":"datetime"}
        payload = [app,"GPU",version,"GPU","F"]
        mqtt_send_status(log_payload,app,payload)
        log_payload = {"Status":status,"Units_of_Measure":"string"}
        payload = [app,"Status",status,"Status","string"]
        mqtt_send_status(log_payload,app,payload)
    elif app == "LifeByte":
        log_payload = {"Msg Count":version,"Units_of_Measure":"Integer"}
        payload = [app,"Count",version,"Count","integer"]
        mqtt_send_status(log_payload,app,payload)
        log_payload = {"Restarted":started,"Units_of_Measure":"datetime"}
        payload = [app,"Restarted",started,"Restarted","datetime"]
        mqtt_send_status(log_payload,app,payload)
        log_payload = {"Status":status,"Units_of_Measure":"string"}
        payload = [app,"Status",status,"Status","string"]
        mqtt_send_status(log_payload,app,payload)
    else:
        log_payload = {"Version":version,"Units_of_Measure":"Float"}
        payload = [app,"Version",version,"Version","Float"]
        mqtt_send_status(log_payload,app,payload)
        log_payload = {"Started":started,"Units_of_Measure":"datetime"}
        payload = [app,"Started",started,"Started","datetime"]
        mqtt_send_status(log_payload,app,payload)
        log_payload = {"Status":status,"Units_of_Measure":"string"}
        payload = [app,"Status",status,"Status","string"]
        mqtt_send_status(log_payload,app,payload)

def appstate(app_name):
    global applist
    applist = init_tmp2()
    if app_name not in applist[:]:
        status = "Down"
    else:
        status = "Up"
    return status
