#!/usr/bin/env python

# At system Startup
# Check Database and update control if needed

import sys
import linecache
import time
from time import mktime
from datetime import date, datetime
from dbchecker import dbcheck
from dbfunctions import dbopen,write_control_n,write_control_t,write_control,read_control,dbsql,dbopeninit
from utilities import  startapp, text2time, init_tmp2,set_prefix,printm

DBUpdateVersion = '1.20'
set_prefix("DBUPD")

try:
    cnx = dbopeninit()
    dstart = datetime.now()

    # check if restart or start, before doing dbcheck
    dbcheck(cnx)  # Make sure all new database fields have been created and db integrity

    printm( 'Version ',DBUpdateVersion)
    # Update System Control Table With Loader Stats
    write_control_t(cnx,'DBUpdateVersion',DBUpdateVersion)
    dstart = time
    Start =dstart.strftime("%m/%d/%Y %H:%M:%S")
    # Loader Start Time
    write_control_t(cnx,'DBUPDStart',Start)

except Exception as inst:
        exc_type, exc_obj, tb = sys.exc_info()
        f = tb.tb_frame
        lineno = tb.tb_lineno
        filename = f.f_code.co_filename
        linecache.checkcache(filename)
        line = linecache.getline(filename, lineno, f.f_globals)
        errorstart = datetime.now()
        ErrorTime =errorstart.strftime("%m/%d/%Y %H:%M:%S")
        printm(' EXCEPTION IN ({}, LINE {}  {} '.format(filename, lineno,  line.strip()))
        printm('Execution: ',exc_obj)
        with open("/home/pi/gw2/errorDBUPD.txt","a") as text_file:
            text_file.write("DBUPD: {}  EXCEPTION IN ({}, LINE {} ): {} \n".format(ErrorTime, filename, lineno,line.strip() ))
        printm(type(inst))
        with open("/home/pi/gw2/errorDBUPD.txt","a") as text_file:
            text_file.write("DBUPD: {} instruction {} \n".format(ErrorTime,type(inst)))
        printm(inst.args)
        with open("/home/pi/gw2/errorDBUPD.txt","a") as text_file:
            text_file.write("DBUPD: {} arguments {} \n".format(ErrorTime,inst.args))

