 #! /usr/bin/python

# Overseer
# Monitor Status for

__author__ = "glenn"
__date__ = "$Jan 28, 2016 6:01:09 PM$"
__date__ = "$June 30, 2024 4:01:09 PM$"

import os
import sys
import time
import linecache
from time import mktime
import json
from updateDb import updateDb
from dbchecker import dbcheck
#from typing import Sequence
from datetime import date, datetime, timedelta
from dbfunctions import dbopen,write_control_n,write_control_t,write_control,read_control,dbsql
from utilities import  startapp, text2time, init_tmp2, set_prefix,printm

HealthCheckVersion = '3.17'
set_prefix("Hck")
cnx=0
write_control_t(cnx,'HCVersion',HealthCheckVersion)
write_control_n(cnx,'HCPID',os.getpid())
dstart = datetime.now()
Start =dstart.strftime("%m/%d/%Y %H:%M:%S")
# Loader Start Time
write_control_t(cnx,'HCPID',Start)
printm(' Process Id = ',os.getpid())

dstart = datetime.now()
LoopTime =dstart.strftime("%m/%d/%Y %H:%M:%S")
printm(HealthCheckVersion,' Start Time: ',LoopTime)

# Reset loop counter for app restart
HCKLoop = 0
cmdresetcount = 3
sendresetcount = 3

while 1:
    try:
        #  Monitor and Start if not running
        #
        dstart = datetime.now()
        LoopTime =dstart.strftime("%m/%d/%Y %H:%M:%S")
        printm( 'Loop Time: ',LoopTime)
        #  Check if Server defined

        row = read_control(cnx,'Server')
        server = row[3].strip()
        #
        # Check on Commander and Sender to be sure they are running
        # Make sure we have connection to the Internet
        #
        # If no Server Defined then skip testing
        if len(server) > 5:
            # Check on Commander
            row = read_control(cnx,'LastCmdSend')
            #printm('Last Cmd  Time: ',row[3])
            lastsend = row[3]
            timestamp_format = "%m/%d/%Y %H:%M:%S" 

            # Convert the string timestamps to datetime objects
            printm( 'Last Data Send Time: ',lastsend)
            try:
                dt1 = datetime.strptime(LoopTime, timestamp_format)
                dt2 = datetime.strptime(lastsend, timestamp_format)
                time_diff = dt1 - dt2
            except ValueError:
                printm('Error in date format ',lastsend,'--')
                time_diff = timedelta(seconds=0)
                pass

            diff_seconds = int(time_diff.total_seconds())
            printm(f' Time since last Cmd Send {diff_seconds} seconds')
            if (diff_seconds  > 301) :
                printm(f' Servver is {server} and cmdresetcount is {cmdresetcount}')
            # if no command in last 10 minutes, but Internet is working, then commander is hung
            #
            if (diff_seconds  > 301) and len(server) > 5 and cmdresetcount == 0:     # has not sent command in over 5 minutes * 4
                row = read_control(cnx,'CmdPID')
                PID = row[2]
                printm('Terminating: Cmd PID: ',PID)
                killcmd = "sudo kill "+str(PID)
                printm('Kill Command: ',killcmd)
                os.system(killcmd)
                cmdresetcount = 3
            else:
                if cmdresetcount == 0:
                    cmdresetcount = 3
                else:
                    cmdresetcount -= 1

            # Check on Sender
            row = read_control(cnx,'LastSendSend')
            #printm( 'Last Data Send Time: ',row[3])
            lastsend = row[3]

            # Convert the string timestamps to datetime objects
            printm( '2Last Data Send Time: ',lastsend)
            try:
                dt1 = datetime.strptime(LoopTime, timestamp_format)
                dt2 = datetime.strptime(lastsend, timestamp_format)
                time_diff = dt1 - dt2
            except ValueError:
                printm('Error in date format ',lastsend,'--')
                time_diff = timedelta(seconds=0)
                pass

            diff_seconds = int(time_diff.total_seconds())
            printm(f' Time since last Data Send {diff_seconds} seconds')
            if (diff_seconds  > 301) :
                printm(f' Servver is {server} and sendresetcount is {sendresetcount}')
            #
            # if no send in last 10 minutes, but Internet is working, then send is hung
            #
            if (diff_seconds  > 301) and len(server) > 5 and sendresetcount == 0:     # has not sent command in over 5 minutes (1 is normal
                row = read_control(cnx,'SendPID')
                PID = row[2]
                printm( 'Terminating: Send PID: ',PID)
                killcmd = "sudo kill "+str(PID)
                printm('Kill Command: ',killcmd)
                os.system(killcmd)
                sendresetcount = 3
            else:
                if sendresetcount == 0:
                    sendresetcount = 3
                else:
                    sendresetcount -= 1

        printm( 'Nap time')
        time.sleep(90)   ####  Sleep for 90 seconds
        HCKLoop = HCKLoop + 1

    except Exception as inst:
            exc_type, exc_obj, tb = sys.exc_info()
            f = tb.tb_frame
            lineno = tb.tb_lineno
            filename = f.f_code.co_filename
            linecache.checkcache(filename)
            line = linecache.getline(filename, lineno, f.f_globals)
            errorstart = datetime.now()
            ErrorTime =errorstart.strftime("%m/%d/%Y %H:%M:%S")
            printm(' EXCEPTION IN ({}, LINE {}  {} '.format(filename, lineno,  line.strip()))
            printm('Execution: ',exc_obj)
            with open("/home/pi/gw2/errorhck.txt","a") as text_file:
                text_file.write("Hck: {}  EXCEPTION IN ({}, LINE {} ): {} \n".format(ErrorTime, filename, lineno,line.strip() ))
            printm(type(inst))
            with open("/home/pi/gw2/errorhck.txt","a") as text_file:
                text_file.write("Hck: {} instruction {} \n".format(ErrorTime,type(inst)))
            printm(inst.args)
            with open("/home/pi/gw2/errorhck.txt","a") as text_file:
                text_file.write("Hck: {} arguments {} \n".format(ErrorTime,inst.args))
            continue
            raise
