#! /usr/bin/python

__author__ = "glenn"
__date__ = "$Mar 16, 2024 "
import os, bz2
import linecache
import time
from time import mktime
import sys
import requests
from datetime import date, datetime, timedelta
import pytz
#import MySQLdb
from dbfunctions import dbopen,write_control_n,write_control_t,write_control,read_control,dbsql,dbsqlw,dbopeninit,dbsql2
from utilities import getgwid, set_prefix, printm, init_tmp2
import gw2mqttsend as mqttsend
from gw2checkhealth import *

set_prefix('send')

SendVersion = '2.52'
printm( SendVersion ,' Started')

healthevent = 0

def UpdateSent():
#
# Update Last Sent Time
#
    dlooptime = datetime.now()
    LastSendStatus = dlooptime.strftime("%m/%d/%Y %H:%M:%S")
    #cnx = dbopen()
    cnx = 0
    write_control_t(cnx,'LastSendSend',LastSendStatus)

def CheckDhome():
    global cnx,url, senderror,senderrordelay , senderrorcount
    #cnx = dbopen()
    cnx = 0
    row = read_control(cnx,'Dhome')
    dhome = row[3]
    row = read_control(cnx,'Server')
    server = row[3].strip()
    if len(server) < 1:
        server = '..'

    # Get current url for to send data to
    if url != server + dhome:
        url = server + dhome
        printm('Dhome - Changed Send Data to: ',url)
        senderror = 0
        senderrordelay = senderrorcount

#
# Get the flush cycle count
#
def getflushlimit():   # flush fifo max one time flush count
    global cnx
    cnx = 0
    row = read_control(cnx,'FlushLimit')     # max to flush at one time
    FlushLimit = row[2]
    return FlushLimit

def getflushcycle():    # flush fifo cycle in loop seconds
    global cnx, Fsend
    cnx = 0
    row = read_control(cnx,'FlushCycle')     # hours between flush of FIFO
    FlushLimithours = row[2]
    flushcycle = (FlushLimithours * 3600 )/Fsend   # flush in loop seconds inside send cycle
    return flushcycle

def FlushFifo(flushlimit):
    global cnx
    #cnx = dbopen()
    cnx = 0
    #
    # flush fifo send queue with data over 140(5 mo) days  old
    #
    FlushTime = (datetime.now() - timedelta(days=140)).strftime('%Y-%m-%d %H:%M:%S')
    sql = "delete from fifo  where CTime < '"+str(FlushTime)+"' limit "+str(flushlimit)
    printm(" Flushing sent data cmd:" + sql)
    cursor = dbsqlw(cnx,sql)

def serverstatusck(newstatus):
    global lastserverstatus
    if lastserverstatus != newstatus:
        if lastserverstatus == 1:
            # Server connection is lost
            lastserverstatus = 0
            write_control_n(0,'ServerStatus',0)
            printm('Server Status Offline')
        else:
            # Server Now Connected
            lastserverstatus = 1
            write_control_n(0,'ServerStatus',1)
            printm('Server Status Online')
#
#  Main - send setup
#
cnx = dbopeninit()
#cnx = dbopen()
cnx = 0
write_control_n(cnx,'SendPID',os.getpid())
printm(' Process Id = ' , os.getpid())

Fsend = 10
printm("No Change Check send set to: ",Fsend," seconds")
write_control_n(cnx,"Fsend",Fsend)

SendState = 0       # Track Send Status
write_control_n(cnx,'SendState',SendState)

mac = getgwid()
printm('Gateway Id: '+str(mac))


senderror = 0
senderrorcount = 5         # Number of delays in sending
senderrordelay = 5          # Number of delays in sending working count
url ="Not defined Yet"
CheckDhome()
printm('Send Data to: '+url)

ckhomeloop = 1
rxsend=0
sendcycle = 1
sendnow = sendcycle
dstart = datetime.now()
Start =dstart.strftime("%m/%d/%Y %H:%M:%S")
write_control_t(cnx,'SendStart',Start)
write_control_t(cnx,'SendVersion',SendVersion)
printm('Sender Initialized, cleaning fifo')

FlushFifo(20000)    # One time startup bulk purge
flushcycle = getflushcycle()
flushlimit = getflushlimit()

global spbsequence
# reset connected status on restart
write_control_n(0,'MQTTStatus',0)

lastserverstatus = 0   # Status of connection to JemRF server

while True:
    try:
        printm( 'Starting send data loop.')
        #
        # Main loop for blocks to send, 10 blocks of 10
        # Loop 2, build block, read up to 10 records, track which the set them sent when successful

        # is Server and Token Set
        #  Read FIFO and Send
        maxsendblock = 10
        norecords = 0
        # mqtt persistent variables
        #mqttc = None
        nodeId = None
        unacked_publish = None
        spbsequence = 1

        try:
            while maxsendblock > 1:
                sendindex = []
                passone = 0
                jsond = '{ "Gateway": "'+mac[:17]+'","Times":['
                #cnx = dbopen()
                cnx = 0
                record = dbsql2(1," select * from fifo where Sent=0 order by CTime desc limit 10;")
                #record = cursor.fetchall()
                if len(record) == 0:
                    maxsendblock = 1
                    norecords = 1
                    #printm("Debug fifo empty")
                if norecords == 0:
                    for row in record:
                        #print(row)
                        fifo_index = row[0]
                        sendindex.append(row[0])
                        if passone > 0:
                            jsond = jsond + ","
                        jsond = jsond + ' {"Time":"'
                        jsond = jsond + row[2].strftime("%Y/%m/%d %H:%M:%S")+'",'
                        sensordata = row[3]
                        mqtt_send = sensordata
                        sensordata = sensordata[:sensordata.find('}]}')+3]
                        jsond = jsond + sensordata
                        passone = 1

                        rxtime = row[2].strftime("%Y/%m/%d %H:%M:%S")

                        # New MQTT Data to send if enabled?
                        mqtt_skip = 0
                        Smqtt = row[4]
                        if Smqtt == 0:
                            # Send MQTT If Enabled
                            #printm("t1 - " + rxtime)
                            mqtt_enabled = read_control(0,'MQTTEnabled')
                            mqtt_status = read_control(0,'MQTTStatus')

                            if mqtt_enabled[2] == 1 or mqtt_status[2] == 1:
                                #print("MQTT Enabled or Status true")

                                dt_utc = datetime.strptime(rxtime, "%Y/%m/%d %H:%M:%S")

                                # Set timezone to UTC
                                utc_timezone = pytz.timezone("UTC")

                                # Localize the datetime object to UTC
                                dt_utc = utc_timezone.localize(dt_utc)

                                # Convert datetime object to Eastern Time
                                eastern_timezone = pytz.timezone("US/Eastern")
                                dt_eastern = dt_utc.astimezone(eastern_timezone)

                                # Format the datetime object as a string
                                rxtime = dt_eastern.strftime("%Y/%m/%d %H:%M:%S")
                                #printm("t2 - " + rxtime)
                                try:
                                    mqttsend.send_mqtt(mqtt_send, fifo_index,spbsequence,rxtime,0)
                                except:
                                    printm("MQTT Send Failure")
                                    write_control_n(0,'MQTTStatus',0)
                                    pass
                                spbsequence += 1
                            else:
                                mqtt_skip = 1

                    rxsend=1
                    nourl = 0
                    if url.find("http") != 0:
                        printm("Cancelled no Server")
                        nourl = 1
                        url_results = 200
                        serverstatusck(0)
                    else:
                        if senderror > 3:
                            printm("Had Send Error, Skipping Send")
                            if senderrordelay > 0:
                                senderrordelay -= 1
                            else:
                                senderror = 2
                                senderrordelay = senderrorcount
                                
                            nourl = 1
                            url_results = 200
                        else:
                            try:
                                jsond = jsond + ']}'
                                printm('Sending:  ' + str(jsond))
                                jsond = dict(data=jsond)
                                r =requests.post(url,data=jsond, timeout=10)
                                rxsend=0
                                r.raise_for_status()
                                url_results = r.status_code
                                senderror = 0                   # reset send error count
                                senderrordelay = senderrorcount
                            except requests.exceptions.HTTPError as errh:
                                if senderror == 0:
                                    printm ("Http Error:",errh)
                                senderror += 1
                                url_results = errh.args[0]
                            except requests.exceptions.ConnectionError as errc:
                                if senderror == 0:
                                    printm ("Error Connecting:",errc)
                                senderror += 1
                                url_results = errh.args[0]
                            except requests.exceptions.Timeout as errt:
                                if senderror == 0:
                                    printm ("Timeout Error:",errt)
                                senderror += 1
                                url_results = errh.args[0]
                            except requests.exceptions.RequestException as err:
                                printm ("OOps: Something Else",err) 
                                url_results = errh.args[0]
                            except:
                                url_results = 199
                                serverstatusck(0)
                                printm("Send: Unknown Error, no response from receiver " + str(url_results))

                    if url_results == 200:
                        #   print 'Send: debugging response'
                        #   print r
                        if nourl == 1:
                            reply = "OK"
                            reply_good = 0
                        else:
                            reply = r.text
                            reply_good= reply.find('propertyA')
                            serverstatusck(1)

                        if reply.find('Failed') != -1 or reply_good == -1:
                            printm('Send Failure '+ r.text)
                            SendState = 4
                            write_control_n(cnx,'SendState',SendState)
                            time.sleep(20)
                            SendState = 0
                            write_control_n(cnx,'SendState',SendState)
                            serverstatusck(0)
                        else:
                            printm("Setting Sent flag")
                            for clearrow in sendindex:
                                #printm(sql)
                                sql = "update fifo set Sent=1 where idfifo ="+ str(clearrow) +";"
                                if mqtt_skip == 1:
                                    sql = "update fifo set Sent=1,Smqtt=1 where idfifo ="+ str(clearrow) +";"
                                #printm(sql)
                                #cnx = dbopen()
                                cnx = 0
                                cursor = dbsqlw(cnx,sql)
                                #printm('send: Cleared fifo id = ' + str(clearrow))

                            UpdateSent()    # let Loader Know we are trying
                            if SendState != 0:
                                SendState = 0               #  Send is now working, clear lock flag
                                #cnx = dbopen()
                                cnx = 0
                                write_control_n(cnx,'SendState',SendState)

                        time.sleep(.1)
                    else:
                        if nourl == 1:
                            printm("No URL So discard Jemrf data")
                            for clearrow in sendindex:
                                sql = "update fifo set Sent=1 where idfifo ="+ str(clearrow) +";"
                                # No MQTT to Send clear that flag alaos
                                if mqtt_skip == 1:
                                    sql = "update fifo set Sent=1,Smqtt=1 where idfifo ="+ str(clearrow) +";"
                                #printm(sql)
                                #cnx = dbopen()
                                cnx = 0
                                cursor = dbsqlw(cnx,sql)
                        else:
                            if senderror < 1:
                                printm('Send: Post New Data Failed, Status Code: ' + str(url_results) + " URL: " + url)
                                serverstatusck(0)

                                if url_results != 199:
                                    errorstart = datetime.now()
                                    ErrorTime =errorstart.strftime("%m/%d/%Y %H:%M:%S")
                                    with open("/home/pi/gw2/errorstatuscode.log","a") as text_file:
                                        text_file.write("Send: {} Status Error: {} \n".format(ErrorTime, str(url_results) ))
                                    #
                                    # Change Server status to Not Connected

                            UpdateSent()    # let Loader Know we are trying
                            if url_results == 504:
                                time.sleep(10)
                            else:
                                time.sleep(30)

                        CheckDhome()    # bad Url get fixed?

                maxsendblock = maxsendblock-1
        except:
            printm('Send: Tx/Rx Fault')
            SendState = 4
            write_control_n(cnx,'SendState',SendState)
            time.sleep(20) #Allow time for rx error to clear
            CheckDhome()    # bad Url get fixed?
            pass

#        print 'send: Did we finish flushing the buffer: ',maxsend
        if norecords == 1:
            printm('No data to upload sleeping for '+str(Fsend)+' seconds, check count is '+str(ckhomeloop))
            time.sleep(Fsend)    # No new data to send
            ckhomeloop -= 1
            if ckhomeloop == 0:
                ckhomeloop = 5
                CheckDhome()
                CheckHealth(0)
            #
            #  See if Controls changed
            #
            NSrate = dbsql2(0,"select Cnumber from control where Control = 'Fsend'")
            NSrate =NSrate[0]
            if NSrate != Fsend:
                Fsend = NSrate
                printm("Sample Rate set to: "+str(NSrate)+" seconds")
            flushcycle = flushcycle - 1
            if flushcycle < 1:
                printm('FLushing Fifo of '+str(flushlimit)+' records')
                FlushFifo(flushlimit)
                flushcycle = getflushcycle()    # reset cycle to new value
                flushlimit = getflushlimit()    # reset limit to new value
                printm('Flush Fifo cycle is ' +str(flushcycle) +' seconds, Limit is '+str(flushlimit))

        else:
            printm('Buffer not empty take short break and continue')
            time.sleep(1)
#
# Update Last Sent Time
#
        UpdateSent()

#  Trap on Control C abort, clear buffers and close database

    except KeyboardInterrupt:
            printm('Exiting')
            write_control_n(0,'MQTTStatus',0)
            mqtt.mqtt_exit()
            cnx.close()
            sys.exit()

#
#   trap errors and log count, then wait 30 seconds and try again
#  Toggle LEDs to Red

    except Exception as inst:
        if rxsend == 0:
            exc_type, exc_obj, tb = sys.exc_info()
            f = tb.tb_frame
            lineno = tb.tb_lineno
            filename = f.f_code.co_filename
            linecache.checkcache(filename)
            line = linecache.getline(filename, lineno, f.f_globals)
            errorstart = datetime.now()
            ErrorTime =errorstart.strftime("%m/%d/%Y %H:%M:%S")
            printm('EXCEPTION IN ({}, LINE {}  {} '.format(filename, lineno,  line.strip()))
            printm('Execution: ' + str(exc_obj))
            with open("/home/pi/gw2/errorsend.log","a") as text_file:
                text_file.write("Send: {}  EXCEPTION IN ({}, LINE {} ): {} \n".format(ErrorTime, filename, lineno,line.strip() ))
            printm(type(inst))
            with open("/home/pi/gw2/errorsend.log","a") as text_file:
                text_file.write("Send: {} instruction {} \n".format(ErrorTime,type(inst)))
            printm(inst.args)
            with open("/home/pi/gw2/errorsend.log","a") as text_file:
                text_file.write("Send: {} arguments {} \n".format(ErrorTime,inst.args))
        else:
            printm('Send Message trap, no response from receiver')
            row = dbsql2(1,"select * from control where Control='Losses'")
            Losses = row[2] + 1
            write_control_n(cnx,'Losses',str(Losses))
        row = read_control(cnx,'ExecptionsSend') # update Execption counter
        drops = row[2]+1
        write_control_n(cnx,'ExecptionsSend',drops)
        SendState = 4
        write_control_n(cnx,'SendState',SendState)
        time.sleep(30)
        SendState = 0
        write_control_n(cnx,'SendState',SendState)
        continue
        raise
    except:
        printm( "Unexpected error:", sys.exc_info()[0])
        with open("/home/pi/gw2/errorsend.log","a") as text_file:
            text_file.write("Send: {} arguments {} \n".format(ErrorTime,sys.exc_info()[0]))
        os.system(Value + " |mail -s 'Gateway "+mac+" Message Send Execption' glenn.seaton@seltron.com &")
        raise
