#! /usr/bin/python
# JemRF Receiver

from dbfunctions import dbopen, write_control_n, write_control_t, write_control, read_control, dbsqlw,dbsql2, dbsqlblock, dbopeninit
from utilities import getgwid, set_prefix, printm
from datetime import date, datetime
import serial
import sys
import pytz
import time
from time import mktime
import linecache
import os
import RPi.GPIO as GPIO

startedcount = 0
starteddevice =""
def process_message(devID,data):
    # Add code to process inbound radio messages
    global startedcount,starteddevice,listcount, last_devID, last_data, rfr_started, rfrset_count, rft_laststart,rfr_devid,laststartedId,RFreceiver_reset

    rf4 = 0
    sendmessage = ""
    local_timezone = pytz.timezone('GMT')  # Adjust to your local timezone
    local_time = datetime.now(local_timezone)
    dt_date = local_time.strftime('%Y-%m-%d %H:%M:%S.%f')
    dt_msec = int(time.time() * 1000)
    dt_date =  local_time.strftime('%Y-%m-%d %H:%M:%S') + '.' + str(dt_msec % 1000).zfill(3)
    printm("Received at "+ dt_date + " from: " + devID + " : " + data)
    if len(devID) > 2:
        rf4 = 1
    # count Started messages
    if data[:7] == 'STARTED':
        if laststartedId == devID:
            rfrset_count += 1
        laststartedId = devID
        started_event = time.time()
        printm("Started Time delta ",started_event-rft_laststart)
        # if delta time is greater than 1 second if is a restart Started message
        if started_event-rft_laststart > 1:
            printm("Count is ",rfrset_count)
            if rfrset_count > 6:
                printm("Started implies RF Hung, Id: ",devID)
                if devID == rfr_devid:
                    resetRFreceiver(rfrset_count)
                    RFreceiver_reset = 1
                else:
                    # Bad Sensor, put in bad sensor list
                    logtime = local_time.strftime('%Y-%m-%d %H:%M:%S')
                    sql = f'select * from Sensorerrors where deviceid = {devID}'
                    row = dbsql2(0,sql)
                    #printm('Row = ',row)
                    if not row:
                        printm(f' Device Id: {devID} is being added to list at {logtime}')
                        sql = f"insert into Sensorerrors (deviceid,issue,RxTime) values ({devID},'Started Error','{logtime}');"
                        dbsqlw(0,sql)
                    else:
                        printm(f' Device Id: {devID} is  in list')

                rfrset_count = 0
        elif devID != rfr_devid:
            # Not the RF Receiver, just a sensor, Starting do we send a Started message?
            printm("Started 1 message from sensor, not RF Receiver, Id: ",devID)
            if laststartedId == devID:
                startedcount += 1
                if startedcount > 3:
                    startedcount = 0
                    row  = read_control(0,"SendCmdEnabled")
                    sendenabled = row[2]
                    if sendenabled == 1:
                        row = read_control(0,"SendInterval")
                        SendInterval = row[2]
                        SendIntervaltext = str(SendInterval).zfill(3)
                        if rf4 == 1:
                            sendmessage = f"b{devID}INVL{SendIntervaltext}"
                        else:
                            sendmessage = f"a{devID}INTVL{SendIntervaltext}"
                        # Send Started message
                    if int(sendenabled)  == 2:
                        row = read_control(0,"SendRFChannel")
                        SendRFChannel = row[2]
                        # Send Started message with Sensor Id
                        if rf4 == 1:
                            sendmessage = f"b{devID}ATCN{SendRFChannel}  "
                        else:
                            sendmessage = f"a{devID}ATCN{SendRFChannel}    "
                    if int(sendenabled)  == 3:
                        row = read_control(0,"SendRFNomsg")
                        SendRFChannel = row[2]
                        # Send Started message with Sensor Id
                        if rf4 == 1:
                            sendmessage = f"b{devID}NOMSG{SendRFChannel} "
                        else:
                            sendmessage = f"a{devID}NOMSG{SendRFChannel}   "
                    if int(sendenabled)  > 0:
                        printm("Sending message to sensor ",sendmessage)
                        # Send Started message with Sensor Id and Device Id
                        time.sleep(.2)
            else:
                laststartedId = devID
                startedcount = 0

        rft_laststart = time.time()
        return sendmessage
    
    if last_devID == devID:
        if last_data == data:
            printm("Duplicate data")
            return
        else:
            last_data = data
    else:
        last_devID = devID
        last_data = data

    #printm("New data")

    newdata = 0
    value = -99
    wtactive = 0                    # number of wireless devices
    wtactivelist = ''

    LastTemp = {}
    LastSend = {}
    

    if data[:2] == 'OK':
        # test hardware reply
        if data[:3] == 'OK-':           # older receiver
            rfr_devid = devID
            rf_version = data[4:8]
            rf_channel = data[8:]
        else:
            rfr_devid = devID           # newer RF-4 receiver
            rf_version = data[3:8]
            rf_channel = data[2:3]

        printm(f"Have RF Info to Store, RF Version: {rf_version}, RF Device Id: {rfr_devid}, RF Channel: {rf_channel}")
        write_control_t(0, 'RFVersion', rf_version)
        write_control_t(0, 'RFDeviceId', rfr_devid)
        if not rf_channel.isdigit() or int(rf_channel) < 0 or int(rf_channel) > 9:
            printm("Invalid RF Channel, defaulting to 0")
            rf_channel = 0
        else:
            rf_channel = int(rf_channel)
        write_control_n(0, 'RFChannel', rf_channel)   # capture current Channel #

    elif rf4 == 0 and devID < "09":    # Test and skip messages from controllers
        return
    
    elif data[:4] == 'RSSI':
        if rf4 == 1:
            value = float(data[4:])
        else:
            value = float(data[4:7])
        newdata = 1
        sensor = '83-'+devID

    elif data[:4] == 'TMPA' or data[:4] == 'TMPB' or data[:4] == 'TMPC' or (rf4 == 1 and data[:2] == 'TM' or data[:2] == 'TA'):
        offset = 4
        if rf4 == 1:
            offset = 2
        dvalue = data[offset:].rstrip("-")
        temp_c = float(dvalue)
        value = temp_c
        #print("xxtemp value: " + str(value))
        row  = read_control(0,"TempScale")
        if row[2] == 1:
            value = temp_c * 9.0 / 5.0 + 32.0
        value = round(value, 2)
        newdata = 1
        sensor = '63-'+devID

    data = data.replace("-", " ")
    #print("passing by with data: " + str(data))
    if data[:3] == 'HUM' or (rf4 == 1 and data[:2] == 'HM'):
        if rf4 == 1:
            value = float(data[2:7])   
        else:         
            value = float(data[3:7])
        newdata = 1
        sensor = '65-'+devID

    elif data[:4] == 'ANAA'or (rf4 == 1 and data[:2] == 'AA'):
        if rf4 == 1:
            value = float(data[2:7])
        else:
            value = float(data[4:7])
        newdata = 1
        sensor = '57-'+devID

    elif data[:4] == 'BATT'or (rf4 == 1 and data[:3] == 'BAT'):
        if rf4 == 1:
            value = float(data[3:7])
        else:
            value = float(data[4:8])
        sensor = '96-'+devID
        newdata = 1                 # Send Each Voltage Reading

    # STATE and BUTTON Process the Same
    #
    elif data[:5] == 'STATE'or (rf4 == 1 and data[:4] == 'STAT'):
        value = 1
        offset = 4
        if rf4 == 1:
            offset = 3
        if data[offset:7] == 'ON':
            value = 0
        newdata = 1                # Send Each Contact Change
        sensor = '66-'+devID

    elif data[:6] == 'BUTTON' or (rf4 == 1 and data[:4] == 'BUTN'):
        value = 1
        offset = 6
        if rf4 == 1:
            offset = 4
        if data[offset:8] == 'ON':
            value = 0

        newdata = 1                # Send Each Contact Change
        sensor = '66-'+devID

    elif data[:6] == 'RELAYA' or data[:6] == 'RELAYB':
        value = 0
        if data[6:8] == 'ON':
            value = 1

        newdata = 1                # Send Each Contact Change
        sensor = '84-'+devID

    #tagt = datetime.fromtimestamp(mktime(time.gmtime())).strftime('%Y-%m-%d %H:%M:%S')

    tagt = local_time.strftime('%Y-%m-%d %H:%M:%S')

    if newdata > 0:
        #printm(tagt+" Device ID Raw data processed : " + devID +' - ' + data + ' - ' + str(value) + ' - '+str(newdata))
        #
        # Clear the Reset Flag
        rfrset_count = 0
        #  Update Sensor List
        listcount += 1
        mqttkey = devID+data[:4]
        if rf4 == 1:
            mqttkey = devID+data[:2]
            if data[:4] == 'RSSI' or data[:4] == 'STAT':
                mqttkey = devID+data[:4]
            elif data[:3] == 'BAT':
                mqttkey = devID+data[:3]
        if data[:3] == 'HUM':
            mqttkey = devID+data[:3]

        sql = "select * from sensorlist where mqttkey = '"+mqttkey+"'"
        row = dbsql2(0,sql)
        #printm('Row = ',row)
        if not row:
            printm(f' Device Id: '+sensor+' is being added to list at {tagt}')
            sql = "insert into sensorlist (deviceid,mqttkey,lvalue,count,RxTime) values ('"+devID+"','"+mqttkey+"',"+str(value)+","+str(1)+",'"+tagt+"')"
            #printm(sql)
            dbsqlw(0,sql)
        else:
            #printm(' Device Id: '+sensor+' is in list')
            listcount = row[4] + 1
            sql = "update sensorlist set deviceid='"+devID+"',mqttkey='"+mqttkey+"',lvalue="+str(value)+",count="+str(listcount)+",RxTime='"+str(tagt)+"' where mqttkey ='"+mqttkey+"'"
            #printm(sql)
            dbsqlw(0,sql)

        # Track Active Devices
        if sensor not in wtactivelist:
            #printm(' Device Id: '+sensor+' is new to list')
            if wtactive == 0:
                wtactivelist = sensor
            else:
                wtactivelist = wtactivelist+','+sensor
            wtactive = wtactive + 1
            #cnx = dbopen()
            cnx = 0
            write_control(cnx, 'WTactive', wtactive, wtactivelist)
            LastTemp[sensor] = -99
            LastSend[sensor] = 1

            #if devID == NewdevID:
                # is this the first message from the new sensor, update Success status
           #     cursor = read_control(cnx, 'ProcessId')
           #     row = cursor.fetchone()

           #     ProcessId = row[1] + 1000
           #     write_control_n(cnx, 'ProcessId', ProcessId)
           #     write_control_t(cnx, 'SetId', '')
           #     printm(' Device Id Set, Update Process Id and clear Set Id value')
           #     NewdevID = ''

        #printm(' Device Id: '+sensor+' is in list')

        # Store new Data to Send
        tagm = ' Id ='+mac[:17]
        tag = tagt+tagm
        jsond = '{ "Gateway": "' + \
            mac[:17]+'","Time":"'+tagt+'","sensors":[ '
        jsond = '"sensors":[ '

        LastTemp[sensor] = value
        if LastSend[sensor] > 2:
            LastSend[sensor] = 1
        jsond = jsond + \
            '{ "sensor":"'+sensor+'","value":"' + \
            str(float("{0:.2f}".format(value)))+'"}'
        jsond = jsond+']}'
        tagt = local_time.strftime('%Y-%m-%d %H:%M:%S')
        printm(jsond)
        sql = ("insert into fifo (Sent,Smqtt,CTime,CData) values (%s,%s,%s,%s)")
        darray = (0, 0, tagt, jsond)
        dbsqlblock(cnx, sql, darray)
        LastSend[sensor] = LastSend[sensor] + 1


def detect_baud_rate(port, timeout=1):
    BAUD_RATES = [9600, 19200, 38400, 56000]
    while 1:
        for baud in BAUD_RATES:
            try:
                printm(f"Trying baud rate: {baud}")
                with serial.Serial(port, baudrate=baud, timeout=1) as ser:
                    ser.reset_input_buffer()
                    ser.write(bytes(b'+++'))
                    time.sleep(timeout)
                    if ser.in_waiting:
                        data = ser.read(ser.in_waiting)
                        char = data.decode('ascii')
                        printm(f"Received data at {baud}: {char}")
                        dbsqlw(0, f"update control set Ctext='{baud}' where Control='BaudRate'")  # Store Serial Baud Rate
                        return baud
            except Exception as e:
                printm(f"Failed at {baud}: {e}")
        printm("Retrying...")

def main():
    global rf_NewChannel, rf_NewFrequency, RFreceiver_reset,rfrset_count

    port = '/dev/serial0'
    printm('Main loop Started, setting Serial Port set to ', port)
    baud = detect_baud_rate(port)
    printm('Baud Rate Detected: ', baud)

    # open a serial connection using the variables above
    #ser = serial.Serial(port=port, baudrate=baud)
    ser = serial.Serial(
        port= port,\
        baudrate=baud,\
        parity=serial.PARITY_NONE,\
        stopbits=serial.STOPBITS_ONE,\
        bytesize=serial.EIGHTBITS)
    #        timeout=0)
    # wait for a moment before doing anything else
    time.sleep(0.2)

    printm(' Process Id = ', os.getpid())
    printm('Starting Loop')

    if len(rf_NewFrequency) > 1:
        printm("Sending Change Channel ", rf_NewFrequency)
        ser.write(rf_NewFrequency)
        time.sleep(5)   # Allow time to set new channel
        rf_NewFrequency = ''
        resetRFreceiver(0)  #reboot receiver to get new channel activated

    if len(rf_NewChannel) > 1:
        printm("Sending Change Channel ", rf_NewChannel)
        ser.write(rf_NewChannel)
        time.sleep(5)   # Allow time to set new channel
        rf_NewChannel = ''
        resetRFreceiver(0)  #reboot receiver to get new channel activated

    # Flag if receiver is tobe reset
    RFreceiver_reset = 0
    #request RF version information
    ser.write(bytes(b'+++'))
    time.sleep(0.5)
    printm("Waiting for RF Version")
    while True:
        try:
            # Loop on Temperature sensors
            # send on change from last value is GT .5 degrees (sampling error filter)
            while 1:
                try:
                    ser.inWaiting()
                    # read a single character
                    printm(" Waiting for message")
                    char = ser.read()
                    try:
                        char = char.decode('ascii')
                    except:
                        mask = b'\x80'
                        printm("Bad Character Received", char,' -> ',bytes([mask[0] ^ char[0]]))
                        char =''

                    # check we have the start of a LLAP message
                    rf4 = 0
                    #print(f'>>Starting Received: {char} ')
                    if char == 'a' or char == 'b':
                        # start building the full llap message by adding the 'a' we have
                        llapMsg = 'a'
                        if char == 'b':
                            rf4 = 1
                            printm("RF4 Message")
                        '''
                        char = ser.read()
                        try:
                            char = char.decode('utf-8')
                        except:
                            mask = b'\x80'
                            printm("Bad Character2 Received", char,' -> ',bytes([mask[0] ^ char[0]]))
                            char =''
                        '''
                        readcount = 11                        
                        while readcount > 0 and char != "\00":
                            inputstring = ser.read(1)
                            try:
                                char = inputstring.decode('ascii')
                            except:
                                mask = b'\x80'
                                printm("Bad Character3 Received", char,' -> ',bytes([mask[0] ^ char[0]]))
                                break

                            readcount -= 1
                            llapMsg = llapMsg + char
                        
                        if readcount != 0:
                            printm(f'>>Partial message, readcount = {readcount}, llapMsg =={llapMsg}== ')
                            break
                        
                        '''
                        if char == 'a':
                            #printm("Extra A")
                            tbuff = ser.read(11)
                        else:
                            llapMsg = llapMsg + char
                            tbuff = ser.read(10)

                        # read in the next 11 characters form the serial buffer
                        # into the llap message
                        #tbuff = ser.read(11)
                        #printm(f' Starting Message: {tbuff}')
                        tbuff = tbuff.decode('utf-8')
                        llapMsg += tbuff

                        # test if shifted and there is an extra a
                        if tbuff[0:1] == 'a':
                            printm("Rx Error: ",llapMsg)
                            char = ser.read()
                            try:
                                char = char.decode('utf-8')
                            except:
                                mask = b'\x80'
                                printm("Bad Character Received", char,' -> ',bytes([mask[0] ^ char[0]]))
                                char =''

                            if char == 'a':
                                char = ''
                            llapMsg = llapMsg[1:]  + char  # discard a and add last digit
                            char = ser.read()
                            printm(f'skip char = {char}')
                        '''

                        #printm(f'>> Parcing Received: =={llapMsg}== len = {len(llapMsg)}')   
                        if len(llapMsg) > 12:
                            printm("Rx Excess Packet Error: ",llapMsg)
                            break
                        # check if extra 'a' in the message, out of sync
                        if llapMsg[1:2] == 'a' and rf4 == 0:
                            printm(f"Extra A in Message:{llapMsg}, resetting RF Receiver")
                            rfrset_count += 1                 
                            resetRFreceiver(rfrset_count)
                            break
                        # now we split the llap message apart into devID and data
                        if rf4 == 1:
                            devID = llapMsg[1:5]
                            data = llapMsg[5:]
                        else:
                            devID = llapMsg[1:3]
                            data = llapMsg[3:]
                        #
                        if not devID.isalnum():
                            printm("Missing/Bad Device Id in message ",llapMsg)
                        else:
                            sendmessage = process_message(devID,data)
                            if sendmessage is not None:
                                if len(sendmessage) > 1:
                                    printm(f"Message to sensor is {sendmessage} message length = {len(sendmessage)}")
                                    rf_message = bytearray()
                                    rf_message.extend(map(ord, sendmessage))
                                    ser.write(rf_message)

                        if RFreceiver_reset == 1:
                            RFreceiver_reset = 0
                            printm("Request RF version information")
                            ser.write(bytes(b'+++'))
                            time.sleep(0.25)

                    else:
                        if char != "\00" :
                            printm(f'Not an "a" or "b", char is --{hex(ord(char))}--')               

                except Exception as inst:
                    exc_type, exc_obj, tb = sys.exc_info()
                    lineno = tb.tb_lineno
                    printm(f" Trap on IO occurred at line {lineno}: {inst}")
                    time.sleep(.25)

            printm(' End of Loop')
            time.sleep(0.01)

        except KeyboardInterrupt:
            printm('Exiting')
        #
    #           cursor.close()
            cnx.close()
            sys.exit()

def resetRFreceiver(rfrset_count):
    # Reset pin 12 GPIO 18
    printm("Resetting RF Receiver")
    #
    GPIO.output(4,False)
    time.sleep(.25)
    GPIO.output(4,True)
    time.sleep(5)           #allow for restart
    #
    local_timezone = pytz.timezone('GMT')  # Adjust to your local timezone
    local_time = datetime.now(local_timezone)
    write_control(0, 'RFResetCount', rfrset_count,local_time.strftime("%m/%d/%Y %H:%M:%S"))


if __name__ == "__main__":
    try:
        WTVersion = '4.10'
        __author__ = "glenn"
        __date__ = "$June 15, 2025"
        GPIO.setwarnings(False)
        GPIO.setmode(GPIO.BCM)
        GPIO.setup(4,GPIO.OUT)
        GPIO.output(4,True)          # Set Reset pin to True, reset off

        set_prefix('Wtless')

        printm(WTVersion, ' Started RF4')
        #
        laststartedId=''

        # Log Start time and Version
        #cnx = dbopen()
        cnx = 0

        dstart = datetime.now()
        Start = dstart.strftime("%m/%d/%Y %H:%M:%S")
        write_control_t(cnx, 'WTStart', Start)
        write_control_t(cnx, 'WTVersion', WTVersion)
        write_control_n(cnx, 'WTPID', os.getpid())

        mac = getgwid()
        printm(mac)
        # clear Sensor List
        sql = "truncate table sensorlist;"
        printm(sql)
        dbsqlw(0,sql)

        # Init Global Vars
        wtactive = 0                    # number of wireless devices
        wtactivelist = ''
        RFreceiver_reset = 0

        LastTemp = {}
        LastSend = {}

        NewdevID = ''
        rfr_devid = ''

        # Set start values for Loop interfaces to force initial send
        last_data = ""
        last_devID = ""
        listcount = 0

        # On System Start Rx Receiver Reset
        rft_laststart = time.time()
        rfrset_count = 0
        rfreset =  0
        # make sure default RF Channel is set
        rf_channel = read_control(0,"RFChannel")
        rf_channeln = rf_channel[2]
        rf_channelt = rf_channel[3]
        if rf_channelt == "" :
            rf_channelt = str(rf_channeln)
            write_control_t(0,"RFChannel",rf_channelt)
        rf_NewChannel = ""

        if rf_channeln != int(rf_channelt):
            printm("Change Channel from ",rf_channeln, ' to ',rf_channelt)
            reqchch = 'ATCN'
            reqchch += rf_channelt
            reqchch += '    '
            printm("Send Request ", reqchch)
            rf_NewChannel = bytearray()
            rf_NewChannel.extend(map(ord, reqchch))
            rfreset = 1

        
        # make sure default RF Frequency is set
        rf_frequency = read_control(0,"RFFrequency")
        rf_frequencyn = rf_frequency[2]
        rf_frequencyt = rf_frequency[3]
        if rf_frequencyt == "" :
            rf_frequencyt = str(rf_frequencyn)
            write_control_t(0,"RFFrequency",rf_frequencyt)
        rf_NewFrequency = ""

        if rf_frequencyn != int(rf_frequencyt):
            printm("Change Frequency from ",rf_frequencyn, ' to ',rf_frequencyt)
            reqchch = 'ATCH'
            reqchch += rf_frequencyt
            reqchch += '    '
            printm("Send Request ", reqchch)
            rf_NewFrequency = bytearray()
            rf_NewFrequency.extend(map(ord, reqchch))
            write_control_n(0,"RFFrequency",rf_frequencyt)
            rfreset = 1

        if rfreset == 1:
            resetRFreceiver(rfrset_count)

        main()
#
#   trap errors and log count, then wait 30 seconds and try again
#  Toggle LEDs to Red

    except Exception as inst:
        exc_type, exc_obj, tb = sys.exc_info()
        f = tb.tb_frame
        lineno = tb.tb_lineno
        filename = f.f_code.co_filename
        linecache.checkcache(filename)
        line = linecache.getline(filename, lineno, f.f_globals)
        printm(' EXCEPTION IN ({}, LINE {} "{}"): {}'.format(
            filename, lineno, line.strip(), exc_obj))
        printm(' error trap')
        printm(type(inst))
        printm(inst.args)
#
# update Execption counter
        cursor = read_control(cnx, 'ExecptionsWT')
        row = cursor.fetchone()
        drops = row[2]+1

        write_control_n(cnx, 'ExecptionsWT', drops)
        exit()
        pass
# end
