#!/bin/bash
# Update /etc/cron.d/jemrf add:
#* * * * *       root    /home/pi/gw2/html/updatesettings.sh
# update wifi and IP settings
htmlpath="/var/www/html"
cd $htmlpath
if [ -e legacy ]
then
  htmlpath="/home/pi/gw2/html"
  echo "Using Legacy ",$htmlpath
fi
cd $htmlpath
for i in {1..6}
do
  if [ -e ap_yes  ]
  then
      echo "ap_yes"
      if [ -e ap_off ]
      then
        echo "turn on"
        sudo nmcli device connect wlan0       #new code for nmcli
        mv ap_off ap_on
      fi
  fi

  if [ -e ap_no ]
  then
      echo "ap_on"
      if [ -e ap_on ]
      then
        echo "turn off"
        sudo nmcli device disconnect wlan0       #new code for nmcli
        mv ap_on ap_off
      fi
  fi
  # test if new IP

  if [ -e newnetwork.txt ]
  then
        echo "change IP"
        cat base.dhcpcd.conf  newnetwork.txt >newconfig       #new code for nmcli
        sudo mv newconfig /etc/dhcpcd.conf
        mv newnetwork.txt newIPset
        sudo reboot
  else
    echo "No DHCPCD Change in IP"
  fi
  # test if new IP

  if [ -e nmclinetwork.txt ]
  then
      echo "change IP"
      cp nmclinetwork.txt /home/pi/gw2/script/nmclinetwork.sh  #new code for nmcli
      sudo chmod +x /home/pi/gw2/script/nmclinetwork.sh
      sudo /home/pi/gw2/script/nmclinetwork.sh
      mv nmclinetwork.txt nmcliIPset
      sudo systemctl restart gw-cmd
  else
    echo "No NMCLI Change in IP"
  fi

  # Ceck if new time
  if [ -e newtime ]
  then
      echo "Change Time"
      cp newtime /home/pi/gw2/script/newtime
      sudo chmod +x /home/pi/gw2/script/newtime
      sudo /home/pi/gw2/script/newtime
      cat newtime >>changetime
      mv newtime TimeSet
  fi

  # Ceck if new time
  if [ -e newtimezone ]
  then
      echo "Change Time Zone"
      cp newtimezone /home/pi/gw2/script/newtimezone
      sudo chmod +x /home/pi/gw2/script/newtimezone
      sudo /home/pi/gw2/script/newtimezone
      cat newtimezone >>changetimezone
      mv newtimezone TimeSetZone
  fi

  if [ -e newntpserver.txt ]
  then
        echo "change NTP"
        cat base.timesyncd.conf  newntpserver.txt >newntpserver
        sudo mv newntpserver /etc/systemd/timesyncd.conf
        sudo systemctl restart systemd-timesyncd
        sudo timedatectl set-ntp true
        sudo hwclock -w
        mv newntpserver.txt newNTPset
  fi
  if [ -e newntpserver.off ]
  then
        echo "change NTP"
        sudo cp base.timesyncd.conf   /etc/systemd/timesyncd.conf
        sudo systemctl restart systemd-timesyncd
        sudo timedatectl set-ntp false
        mv newntpserver.off newNTPset.off
  fi

  # Check if Shutdown
  if [ -e shutdown ]
  then
    sudo rm $htmlpath/shutdown
    sudo /usr/sbin/shutdown -t0 now
  fi
  # Check if Reboot
  if [ -e reboot ]
  then
    sudo rm $htmlpath/reboot
    sudo /usr/sbin/reboot
  fi
  # Check if Restart wireless
  if [ -e new_rfchannel ]
  then
    sudo systemctl restart gw-wireless
    sudo mv $htmlpath/new_rfchannel $htmlpath/now_rfchannel
  fi
  # Check if System Updates
  if [ -e update_cmd.txt ]
  then
    mv update_cmd.txt /home/pi/gw2/script/update_cmd.sh
    sudo chmod +x /home/pi/gw2/script/update_cmd.sh
    /home/pi/gw2/script/update_cmd.sh
  fi
  # Check if sftp
  if [ -e sftp.txt ]
  then
    echo sending file sftp
    mv sftp.txt /home/pi/gw2/script/sftp.sh
    sudo chmod +x /home/pi/gw2/script/sftp.sh
    /home/pi/gw2/script/sftp.sh

    if [ $? -eq 0 ]
    then
        echo "SFTP_OK" >sftp_OK
        rm -f sftp_Failed
    else
        echo "SFTP_Failed" >sftp_Failed
        rm -f sftp_OK
    fi
  fi
  #
  # Check if remoteadmin
  # Test if need to Disable Remote Admin
  if [ -e RemoteAdmin_off ]
  then
    echo Disable Remote Admin
    mv RemoteAdmin_off  /home/pi/gw2/script/RemoteAdmin_off.sh
    sudo chmod +x /home/pi/gw2/script/RemoteAdmin_off.sh
    /home/pi/gw2/script/RemoteAdmin_off.sh
  fi
  #
  # Test if need to Enable Remote Admin
  if [ -e RemoteAdmin_on ]
  then
    echo Enable Remote Admin
    mv RemoteAdmin_on  /home/pi/gw2/script/RemoteAdmin_on.sh
    sudo chmod +x /home/pi/gw2/script/RemoteAdmin_on.sh
    /home/pi/gw2/script/RemoteAdmin_on.sh
  fi
  #
  # Check to export logs
  if [ -e exportlogs ]
  then
    echo export logs
    tree /var/www/html/ >treehtml.txt
    tree /home/pi/ >treepi.txt
    cat /home/pi/gw2/error* >gw2errors.txt
    zip gw2logs.zip  gw2errors.txt /var/log/syslog /var/log/syslog.1 treehtml.txt treepi.txt
    rm exportlogs
  fi
  echo "loop completed: $i at "
  date
  if [ "$i" -lt  "6" ]
  then
    sleep 10
  fi
done
#
#   Test if time to run transfer
#
/usr/bin/php $htmlpath/sftpnightly.php