#!/usr/bin/env python2
#encoding: windows-1252

# Update Gateway database to be sure all needed fields have been added

#version 4.00  6/5/2025

from dbfunctions import dbopen,dbsqlblock,write_control,valid_control,write_control_n
#import dbfunctions as fl
from utilities import set_prefix,printm
import os

#
#  Used to rebuild database and capture existing SSID and Password
#
def getssid():
    # Read wifi config and see if ssid is set
    ssid = 'Not Assigned'
    exists = os.path.isfile('/home/pi/gw2/wpa_supplicant.conf')
    if exists:
        f=open("/home/pi/gw2/wpa_supplicant.conf","r")
        for x in f:
            if x.find('ssid=') > 0:
                ssid = x[x.find('"')+1:len(x)-2]
        return ssid
    else:
        return ssid

def getpsk():
    # Read wifi config and see if psk is set
    psk = ''
    exists = os.path.isfile('/home/pi/gw2/wpa_supplicant.conf')
    if exists:
        f=open("/home/pi/gw2/wpa_supplicant.conf","r")
        for x in f:
            if x.find('psk=') > 0:
                psk = x[x.find('"')+1:len(x)-2]
        return psk
    else:
        return psk

def updateDb(cnx):
    #cnx = dbopen()
    cnx = 0
    Version = 4
    control = ['IP','Fsend','Nsend','Srate','WiFi','Psk','WiFiDrops']
    control = control + ['ActiveDevices','Loses','Dhome','Chome','LEDon','LEDLevel','LEDVersion','LEDStart']
    control = control + ['LogStart','LogVersion','LogState','LogPID','ExecptionsLog']
    control = control + ['SendStart','SendVersion','LastSendSend','SendState','SendPID','ExecptionsSend']
    control = control + ['CmdStart','CmdVersion','LastCmdSend','CmdState','CmdPID','ExecptionsCmd']
    control = control + ['HCVersion','HCPID','WFState','ExecptionsWT','WTVersion','WTStart','WTactive','WTPID']
    control = control + ['DBUpdateVersion','DBUPDStart','SetId','ProcessId']
    control = control + ['LoaderVersion','LoaderStart','LoaderPID','LoaderLoop']
    #control = control + ['TartgwStart','TartgwPID','TartgwVersion','TartGateway','TartgwSensors','TartGateway','TartgwSensors','TartgwStarted']
    control = control + ['FlushCycle','FlushLimit','TempScale','Znetworks']
    control = control + ['FifoReset','FIFOCount','FIFOQueue','CPUTemp','GPUTemp','LastButton','ButtonCmd','ButtonDuration']
    control = control + ['wifiset','apversion','WRVersion','WRLIPList','WRLPortList','WRLAppList','WRCycle','WRModelList','WRDevicesList','WRPID']
    control = control + ['dbcVersion','dbcLastRun','UtilitiesVersion']
# JemRF controls
    control = control + ['Server','ServerStatus' ,'Token','RFVersion','RFChannel','RFFrequency','RFDeviceId','WSensors','NodeId','NTPServer', 'Timezone','DST']
    control = control + ['Staticip','NetGateway','Subnet','DNS','APEnabled','NodeId','AutoUpdates','SW_Release','RFResetCount','RFCount','StatusInterval']
    control = control + ['SFTP_Enabled','SFTP_Host','SFTP_Port','SFTP_User','SFTP_Password','SFTP_Path','SFTP_Send','SFTP_Delimiter','TX_Domain','TX_Method']
# mqtt
    control = control + ['MQTTEnabled','MQTTVersion','MQTTStatus','MQTTClientId','MQTTBroker','MQTTPort','MQTTUser','MQTTPass','MQTTTopic','MQTTFormat','MQTTrc']
# extras
    control = control + ['RemoteAdmin','BaudRate','SendCmdEnabled','SendInterval','SendRFChannel','SendRFNomsg']
#    print len(control)
    ctrl = 0
    while ctrl < len(control):
        #cnx = dbopen()
        cnx = 0
        if valid_control(cnx,control[ctrl]):
            printm( control[ctrl]+' Exist')
        else:
            dbsqlblock(cnx,'insert into control (Control,Cnumber,Ctext) values (%s,%s,%s)',(control[ctrl],0,''))
            printm( control[ctrl]+' Created')
#
# set Special default values
#
            #cnx = dbopen()
            cnx = 0
            if control[ctrl] == 'SFTP_Port':
                write_control(cnx,'SFTP_Port',0,'22')
            if control[ctrl] == 'Timezone':
                write_control(cnx,'Timezone',0,'America/New_York')
            if control[ctrl] == 'Server':
                write_control(cnx,'Server',0,'https://monitor.jemrf.com')
            if control[ctrl] == 'ProcessId':
                write_control(cnx,'ProcessId',1000,'')
            if control[ctrl] == 'WRLAppList':
                write_control(cnx,'WRLAppList',0,'state.xml')
            if control[ctrl] == 'WRCycle':
                write_control(cnx,'WRCycle',10,'WebRelay Cycle in seconds')
            if control[ctrl] == 'FlushCycle':
                write_control(cnx,'FlushCycle',3,'Flush Cycle in hours')
            if control[ctrl] == 'FlushLimit':
                write_control(cnx,'FlushLimit',20000,' Max Records to Flush')
            #
            #cnx = dbopen()
            cnx = 0
            if control[ctrl] == 'BaudRate':
                write_control(cnx,'BaudRate',1,'9600')
            if control[ctrl] == 'TempScale':
                write_control(cnx,'TempScale',1,'F')
            if control[ctrl] == 'Fsend':
                write_control(cnx,'Fsend',20,'Send cycle in seconds')
#            if control[ctrl] == 'Nsend':
#                write_control(cnx,'Nsend',40,'samples till default send')
            if control[ctrl] == 'Srate':
                write_control(cnx,'Srate',20,'Commander cycle seconds')
            if control[ctrl] == 'LEDLevel':
                write_control(cnx,'LEDLevel',6,'LED Level 4-8 * 10')
            if control[ctrl] == 'Dhome':
                write_control(cnx,'Dhome',0,'/receiver/receiver.php')

            #cnx = dbopen()
            cnx = 0
            if control[ctrl] == 'RFFrequency':
                write_control(cnx,'RFFrequency',3,'3')
            if control[ctrl] == 'Chome':
                write_control(cnx,'Chome',0,'/receiver/gateway.php')
            if control[ctrl] == 'Losses':
                write_control(cnx,'Losses',0,'server connect failures')
            if control[ctrl] == 'ActiveDevices':
                write_control(cnx,'ActiveDevices', 0,'count of Active Devices')
            if control[ctrl] == 'WiFi':
                ssid = getssid()
                write_control(cnx,'WiFi', 0,ssid)
            if control[ctrl] == 'Psk':
                Psk = getpsk()
                write_control(cnx,'Psk', 0,Psk)

        ctrl = ctrl+1
    # Store version of database
    #
    cnx = 0
    write_control_n(cnx,'dbcVersion',Version)
