<?php
include 'dbconnect.php';

if (isset($_GET["datetime"]))
{
    $filter = $_GET["datetime"];
    //echo $filter;
}else
{
    echo "Date Not Defined";
    exit();
}
// Get list of available SSIDs

    $sql = "select * from control";
    $control[] = array();
    $result = mysqli_query($LinkId, $sql);
    while ($row = mysqli_fetch_array($result)) {
        $control[$row["Control"]] = [$row["Cnumber"] ,$row["Ctext"]];
    }
    // Header Fields
    $wlanip = $control['IP'][1];
    $nodeid = $control['NodeId'];
    $deviceid = "JRF".$nodeid[1];
    $timezone = $control['Timezone'][1];
    $connect_status = false;
    $rfversion = $control['RFVersion'][1];
    $rfchannel = $control["RFChannel"][0];
    $rfdevid = $control['RFDeviceId'][1];
    $sftp_delimiter = $control['SFTP_Delimiter'][1];
    $is_Fahrenheit = $control['TempScale'][0];

    if ($sftp_delimiter == '') $sftp_delimiter = ',';


/*
Format
rec+date    rec_time   sensor_id   msg_type  msg_val  msg_unit  Description
04/26/2024  5:35:35 PM   40         AWAKE      null      n/a
04/26/2024  5:35:35 PM   40         HUM         52.21   %       Relative Humidity
04/26/2024  5:35:35 PM   40         TMPA        22.88   C       Temperature
04/26/2024  5:35:35 PM   40         RSSI        -48     db      Receive Signal Strength Indicator
04/26/2024  5:35:35 PM   40         BATT        2.9     V       Battery Voltage

*/

$sql = "set time_zone = '".$timezone."'";

$result = mysqli_query($LinkId, $sql);
$sql = "select *,convert_TZ(CTime,'GMT','".$timezone."') as Ztime   from fifo where date(convert_TZ(CTime,'GMT','".$timezone."'))  = '".$filter."' order by CTime desc limit 30";

$result = mysqli_query($LinkId, $sql);

date_default_timezone_set($timezone);
$datetime = date('Y-m-d H:i:s', time());

include 'header.php';

echo "<tr><td align:center;>Data Dump</td></tr>";
?>

<tr><td><table><tr">
    <td width="30%" style="text-align: center;">Date</td>
    <td width="30%" style="text-align: center;">Time</td>
    <td width="30%" style="text-align: center;">Sensor</td>
    <td width="30%" style="text-align: center;">msg_type</td>
    <td width="30%" style="text-align: center;">msg_value</td>
    <td width="30%" style="text-align: center;">msg_unit</td>
    <td width="30%" style="text-align: center;">Description</td>
    </tr>
<?php
while ($row = mysqli_fetch_array($result)) {
    $jdata = '{'.$row["CData"];
    $data = json_decode($jdata, true); // Use true to decode as associative array

            // Loop through each sensor and value pair
            foreach ($data['sensors'] as $sensor_data) {
                // Access and display sensor and value
                //echo "Sensor: " . $sensor_data['sensor'] . ", Value: " . $sensor_data['value'] . "<br>";
            }

    $timestamp = new DateTime($row["CTime"], new DateTimeZone('UTC'));
    $timestamp->setTimezone(new DateTimeZone($timezone));
    $timestamp = new DateTime($row["Ztime"]);
    //echo $timestamp->format('Y-m-d H:i:s');
    //echo "<br />";

    $msg_type = "";
    $msg_unit = "";
    $msg_desc = "";
    switch (substr($sensor_data['sensor'],0,2)) {
        case "57":
            $msg_type = "ANNA";
            $msg_unit = "lux";
            $msg_desc = "Light Level";
            break;
        case "83":
            $msg_type = "RSSI";
            $msg_unit = "db";
            $msg_desc = "Received Signal Strength Indicator";
            break;
        case "96":
            $msg_type = "BATT";
            $msg_unit = "v";
            $msg_desc = "Battery Voltage";
            break;
        case "63":
            $msg_type = "TMPA";
            if ($is_Fahrenheit == 1) {
                $msg_unit = "F";
                //$sensor_data['value'] = round(($sensor_data['value'] * 9/5) + 32, 2);
            } else { 
                $msg_unit = "C";
            }
            $msg_desc = "Temperature";
            break;
        case "65":
            $msg_type = "HUM";
            $msg_unit = "%";
            $msg_desc = "Relative Humidity";
            break;
        case "66":
            $msg_type = "STATE";
            $msg_unit = "";
            $msg_desc = "State (ON/OFF)";
            break;
        default:
            $msg_type = "";
            $msg_unit = "";
            $msg_desc = "";

        }


    echo "<tr>";
    echo '<td style="text-align: center;">',$timestamp->format("m/d/Y"),'</td><td style="text-align: center;">', $timestamp->format("h:i:sa"),
    '</td><td style="text-align: center;">',substr($sensor_data['sensor'],3),'<td style="text-align: center;">',$msg_type, '</td><td style="text-align: center;">',
    $sensor_data['value'], '</td><td style="text-align: center;">',$msg_unit,'<td style="text-align: center;">',$msg_desc, "</td>";
    echo "</tr>";
}
?>
<tr>
<form method='get' action='dataexport.php'>
<td style='text-align: right;' colspan="2"><label for="datetime">Export To File :</label> </td>
<td><input type="date" id="datetime" name="datetime" hidden value="<?php echo $filter; ?>" /></td>
<td style='text-align: right;'>
<input type='submit' name='submit' style='font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:90px; color: black; background-color: #C0C0C0;' value='Export'>
</td>
<td colspan="4">Delimited by: <input type="text" id="delimiter" name="delimiter" size='1' maxlength='1' value="<?php echo $sftp_delimiter; ?>" />

</td>
</form>
</tr>
<?php
echo "</table></td></tr>";
include 'footer.php';

