<?php
include 'dbconnect.php';

if (isset($_GET["datetime"]))
{
    $filter = $_GET["datetime"];
    //echo $filter;
}else
{
    echo "Date Not Defined";
    exit();
}
if (isset($_GET["delimiter"]))
{
    $sftp_delimiter = $_GET["delimiter"];
    //echo $filter;
}else
{
    $sftp_delimiter = ',';
}
$sql = "update control set Ctext = '$sftp_delimiter' where Control = 'SFTP_Delimiter'";
$result = mysqli_query($LinkId, $sql);

$download = true;
if (isset($_GET["sftp"]))
{
    $download = false;
    echo "Sending SFTP, Generate and Quit";
}
// Get list of available SSIDs
    $sql = "select * from control";
    $control[] = array();
    $result = mysqli_query($LinkId, $sql);
    while ($row = mysqli_fetch_array($result)) {
        $control[$row["Control"]] = [$row["Cnumber"] ,$row["Ctext"]];
    }
    // Header Fields
    $wlanip = $control['IP'][1];
    $nodeid = $control['NodeId'];
    $deviceid = "JRF".$nodeid[1];
    $timezone = $control['Timezone'][1];
    $connect_status = false;
    $is_Fahrenheit = $control['TempScale'][0];

/*
Format
rec+date    rec_time   sensor_id   msg_type  msg_val  msg_unit  Description
04/26/2024  5:35:35 PM   40         AWAKE      null      n/a
04/26/2024  5:35:35 PM   40         HUM         52.21   %       Relative Humidity
04/26/2024  5:35:35 PM   40         TMPA        22.88   C       Temperature
04/26/2024  5:35:35 PM   40         RSSI        -48     db      Receive Signal Strength Indicator
04/26/2024  5:35:35 PM   40         BATT        2.9     V       Battery Voltage

*/
/* Export to File
Opens a file and writes the array data as CSV
foreach($results as $row) {
    fputcsv($fh, (array) $row);
Create and write row
 headers
 close and send
 */

function array2csv(array &$array)
{
    global $sftp_delimiter;
   if (count($array) == 0) {
     return null;
   }
   ob_start();
   $df = fopen("php://output", 'w');
   fputcsv($df, array_keys(reset($array)),$sftp_delimiter);
   foreach ($array as $row) {
      fputcsv($df, $row);
   }
   fclose($df);
   return ob_get_clean();
}

function download_send_headers($file) {
    global $filename;
    if (file_exists($file)) {
        header('Content-Description: File Transfer');
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename='.basename($filename));
        header('Content-Transfer-Encoding: binary');
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Pragma: public');
        header('Content-Length: ' . filesize($file));
        ob_clean();
        flush();
        readfile($file);
    }
}
//flush();
$filename = $filter . ".csv";
//ob_start();
$df = fopen('temp.csv', 'w');
Generatecsv($df);

fclose($df);
if($download){
    download_send_headers("temp.csv");
}

function Generatecsv($df)
{
    global $LinkId,$timezone,$filter,$sftp_delimiter,$is_Fahrenheit;
    $csvrow = array('Date', 'Time', 'Sensor', 'msg_type', 'msg_value', 'msg_unit', 'Description');
    fputcsv($df, $csvrow,$sftp_delimiter);
    //print_r($csvrow);

    $sql = "set time_zone = '".$timezone."'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "select *,convert_TZ(CTime,'GMT','".$timezone."') as Ztime   from fifo where date(convert_TZ(CTime,'GMT','".$timezone."'))  = '".$filter."' order by CTime desc ";
    $result = mysqli_query($LinkId, $sql);
    while ($row = mysqli_fetch_array($result)) {
        $jdata = '{'.$row["CData"];
        $data = json_decode($jdata, true); // Use true to decode as associative array

                // Loop through each sensor and value pair
                foreach ($data['sensors'] as $sensor_data) {
                    // Access and display sensor and value
                    //echo "Sensor: " . $sensor_data['sensor'] . ", Value: " . $sensor_data['value'] . "<br>";
                }

        $timestamp = new DateTime($row["CTime"], new DateTimeZone('UTC'));
        $timestamp->setTimezone(new DateTimeZone($timezone));
        $timestamp = new DateTime($row["Ztime"]);
        //echo $timestamp->format('Y-m-d H:i:s');
        //echo "<br />";

        $msg_type = "";
        $msg_unit = "";
        $msg_desc = "";
        switch (substr($sensor_data['sensor'],0,2)) {
            case "57":
                $msg_type = "ANNA";
                $msg_unit = "lux";
                $msg_desc = "Light Level";
                break;
            case "83":
                $msg_type = "RSSI";
                $msg_unit = "db";
                $msg_desc = "Received Signal Strength Indicator";
                break;
            case "96":
                $msg_type = "BATT";
                $msg_unit = "v";
                $msg_desc = "Battery Voltage";
                break;
            case "63":
                $msg_type = "TMPA";
                if ($is_Fahrenheit == 1) {
                    $msg_unit = "F";
                    //$sensor_data['value'] = round(($sensor_data['value'] * 9/5) + 32, 2);
                } else { 
                    $msg_unit = "C";
                }
                $msg_desc = "Temperature";
                break;
            case "65":
                $msg_type = "HUM";
                $msg_unit = "%";
                $msg_desc = "Relative Humidity";
                break;
            case "66":
                $msg_type = "STATE";
                $msg_unit = "";
                $msg_desc = "State (ON/OFF)";
                    break;
            default:
                $msg_type = "";
                $msg_unit = "";
                $msg_desc = "";

            }

        $csvrow = array($timestamp->format("m/d/Y"), $timestamp->format("h:i:sa"), substr($sensor_data['sensor'],3), $msg_type, $sensor_data['value'], $msg_unit, $msg_desc);
        fputcsv($df, $csvrow,$sftp_delimiter);
    //print_r($csvrow);
    }

}