<?php
include 'dbconnect.php';

$refreshtime = 0;
$reset = 0;

if (isset($_GET["shutdown"])) {
    $refreshtime = getrefreshtime() + 30;
    echo "Shutdown in Queued, please wait ", $refreshtime, " seconds before removing power.";

    $file = fopen("shutdown", "w");
    fwrite($file, "\n");
    fclose($file);
}
if (isset($_GET["reboot"])) {
    $refreshtime = getrefreshtime() + 40;
    echo "Reboot in Queued, please wait ", $refreshtime, " seconds before completes.";

    $file = fopen("reboot", "w");
    fwrite($file, "\n");
    fclose($file);
}

if (isset($_GET["updating"])) {
    $refreshtime = getrefreshtime() + 70;
    echo "Updates in Progress, please wait ", $refreshtime, " seconds before completes, and refresh.";
}

if (isset($_GET["reset"])) {
    //echo "reset";
    readControl();
    $server = "https://monitor.jemrf.com";
    $ssid = "";
    $password = "";
    $pep_token = "";
    $is_Fahrenheit = 1;
    $AutoUpdates = 0;
    $reset = 1;
    // write db updates
    //echo "Clear db";
    //updateControl();
} else {
    if ($_GET['submit'] == 'Save') {
        // read from database here
        readControl();
        $server = trim(filter_input(INPUT_GET, 'server', FILTER_SANITIZE_URL));
        # check for http https and add if missing
        $serverstart = substr($server, 0, 8);
        if (strlen($serverstart) > 5) {
            if ((strpos($serverstart, "http") === false)) {
                if (strpos($serverstart, "://") === false) {
                    $server = "https://" . $server;
                } else {
                    $server = "https" . $server;
                }
            }
        }
        $is_https = $_GET['is_https'];
        $ssid = trim(filterinput($_GET['ssid']));
        $password = trim(filterinput($_GET['password']));
        $pep_token = trim(filterinput($_GET['pep_token']));
        $is_Fahrenheit = $_GET['is_Fahrenheit'];
        $AutoUpdates = $_GET['AutoUpdates'];
        $new_rfchannel = filter_var($_GET['rfchannel'], FILTER_SANITIZE_NUMBER_INT);
        $new_RemoteAdmin = $_GET['RemoteAdmin'];

        // write db updates
        updateControl();
        //
        if (intval($new_rfchannel) != $rfchannel) {
            // change channel, restart wireless app
            $file = fopen("new_rfchannel", "w");
            fwrite($file, "change the channel to  " . $new_rfchannel);
            fclose($file);
            $refreshtime = 22;
            echo "Changing RF Receiver Channel in Progress";
        }
        //
        if (intval($new_RemoteAdmin) != $RemoteAdmin) {
            // change RemoteAdmin
            if ($new_RemoteAdmin == 1) {
                // Enable
                $file = fopen("RemoteAdmin_on", "w");
                fwrite($file, "sudo systemctl start zerotier-one");
            } else {
                // disable
                $file = fopen("RemoteAdmin_off", "w");
                fwrite($file, "sudo systemctl stop zerotier-one");
            }
            fclose($file);
            $refreshtime = 7;
            echo "Changing Remote Admin in Progress";
        }
        // read from database here
        readControl();
    } else {
        // read from database here
        readControl();
    }
}

function getrefreshtime()
{
    $secondsafter = date("s", time());
    while ($secondsafter > 10) {
        $secondsafter = $secondsafter - 10;
    }
    $refreshtime = (15 - $secondsafter);
    return $refreshtime;
}

function filterinput($input)
{
    // echo $input;
    $input = filter_var($input, FILTER_SANITIZE_STRING, FILTER_UNSAFE_RAW);
    // echo ' -> ', $input;
    return $input;
}
// Get list of available SSIDs
function readControl()
{
    global $LinkId, $server, $ssid, $password, $pep_token, $is_Fahrenheit, $wlanip, $deviceid, $serverstatus, $AutoUpdates, $timezone, $rfversion,
        $mqttstatus, $cputemp, $gputemp, $rfdevid, $rfchannel, $RemoteAdmin;

    $sql = "select * from control";
    $control[] = array();
    $result = mysqli_query($LinkId, $sql);
    while ($row = mysqli_fetch_array($result)) {
        $control[$row["Control"]] = [$row["Cnumber"], $row["Ctext"]];
    }
    // Header Fields
    $wlanip = $control['IP'][1];
    $nodeid = $control['NodeId'];
    $deviceid = "JRF" . $nodeid[1];
    $rfdevid = $control['RFDeviceId'][1];
    $rfversion = $control['RFVersion'][1];
    $rfchannel = $control["RFChannel"][0];
    $serverstatus = $control["ServerStatus"][0];
    $mqttstatus = $control["MQTTStatus"][0];
    $RemoteAdmin = $control["RemoteAdmin"][0];

    $server = $control['Server'][1];
    $ssid = $control['WiFi'][1];
    $password = $control['Psk'][1];
    $pep_token = $control['Token'][1];
    if ($control['TempScale'][1] == 'F') {
        $is_Fahrenheit = 1;
    } else {
        $is_Fahrenheit = 0;
    }
    $AutoUpdates = $control['AutoUpdates'][0];
    $timezone = $control['Timezone'][1];
    $cputemp = $control["CPUTemp"][1];
    $gputemp = $control["GPUTemp"][1];
}

function updateControl()
{
    global $LinkId, $server, $ssid, $password, $pep_token, $is_Fahrenheit, $AutoUpdates, $new_rfchannel, $new_RemoteAdmin;

    $sql = "update control set Ctext = '$server' where Control ='Server'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$ssid' where Control ='WiFi'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$password' where Control = 'Psk'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$pep_token' where Control = 'Token'";
    $result = mysqli_query($LinkId, $sql);
    if ($is_Fahrenheit == "1") {
        $TempScale = "F";
    } else {
        $TempScale = "C";
    }
    $sql = "update control set Cnumber = '$is_Fahrenheit', Ctext = '$TempScale' where Control = 'TempScale'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Ctext = '$new_rfchannel' where Control = 'RFChannel'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Cnumber = '$AutoUpdates' where Control = 'AutoUpdates'";
    $result = mysqli_query($LinkId, $sql);
    $sql = "update control set Cnumber = '$new_RemoteAdmin' where Control = 'RemoteAdmin'";
    $result = mysqli_query($LinkId, $sql);
    if (!$result) {
        echo "Error: " . $sql . "<br>" . mysqli_error($LinkId);
    }
}

$systemstatus = shell_exec("ps -aef |grep gw2");
$healthstatus = "#09de42";
//echo "count is ",substr_count($systemstatus, ".py") ;
if (substr_count($systemstatus, ".py") < 5) $healthstatus = '#f78d6d';
if (substr_count($systemstatus, ".py") < 4) $healthstatus = '#f7395c';
if ($cputemp > 160 or $gputemp > 160) {
    $healthstatus = "#ebe534";     // Yellow
}
if ($cputemp >= 175 or $gputemp > 175) {
    $healthstatus = "#f54049";      //Red
}

// if New SSID Start WiFI if not IP
date_default_timezone_set($timezone);
$datetime = date('Y-m-d H:i:s', time());

include 'header.php';
if ($refreshtime > 0)  echo '<meta http-equiv="refresh" content="', $refreshtime, ';URL=setupdetails.php">';
?>

<tr>
    <td columspan='2'>
        <table align='center'>
            <tr>
                <td colspan='2'><span style='color:black;font-family:verdana;font-size:12px;text-align: center;'></span>
                </td>
            </tr>
            <form method='get' action='setupdetails.php'>
                <tr>
                    <td colspan='2' style='text-align: right; color:black;'>WiFi Network/SSID : </td>
                    <td id='selectssid' style='text-align: left' ;><input type='text' name='ssid' disabled value='<?php echo $ssid ?>' onchange="flagchanged(name);"></td>

                    <td></td>
                </tr>
                <tr>
                    <td colspan='2' style='text-align: right; color:black;'>Password : </td>
                    <td style='text-align: left;'><input type='password' name='password' value='<?php echo $password ?>' disabled onchange="flagchanged(name);"></td>

                    <td></td>
                </tr>
                <tr>
                    <td></td>
                    <td colspan="2">
                        <hr>
                    </td>
                    <td></td>
                </tr>
                <tr>
                    <td colspan='2' style='text-align: right; color:black;'>Server : </td>
                    <td style='text-align: left' ;><input type='text' name='server' value='<?php echo $server ?>' onchange="flagchanged(name);"></td>
                </tr>
                <tr>
                    <td></td>
                    <td style='text-align: left' ;><input type='text' name='is_https' value='0' hidden></td>

                    <td></td>
                </tr>
                <tr>
                    <td colspan='2' style='text-align: right; color:black;'>Token : </td>
                    <td style='text-align: left' ;><input type='text' name='pep_token' maxlength='40' disabled value='<?php echo $pep_token ?>' onchange="flagchanged(name);">
                    </td>

                    <td></td>
                </tr>
                <tr>
                    <td></td>
                    <td colspan="2">
                        <hr>
                    </td>
                    <td></td>
                </tr>
                <tr>
                    <td colspan='2' style='text-align: right; color:black;'>Send Temperature in : </td>
                    <td style='text-align: left' ;>
                        <Select name='is_Fahrenheit' onchange="flagchanged(name);">
                            <?php if ($is_Fahrenheit == 1) { ?>
                                <option value='0'>Celsius</option>
                                <option value='1' Selected>Fahrenheit</option>
                            <?php } else { ?>
                                <option value='0' Selected>Celsius</option>
                                <option value='1'>Fahrenheit</option>
                            <?php } ?>
                        </Select>
                    </td>
                    <td></td>
                </tr>
                <tr>
                    <td colspan='2' style='text-align: right; color:black;'>RF Receiver Channel #: </td>
                    <td style='text-align: left' ;><input type='number' name='rfchannel' max="9" min="0" value='<?php echo $rfchannel ?>' onchange="flagchanged(name);"></td>
                    <td></td>
                </tr>

                <tr>
                    <td colspan='2' style='text-align: right; color:black;'>Allow Tech Support : </td>
                    <td style='text-align: left' ;>
                        <Select name='RemoteAdmin' onchange="flagchanged(name);">
                            <?php if ($RemoteAdmin == 1) { ?>
                                <option value='0'>No</option>
                                <option value='1' Selected>Yes</option>
                            <?php } else { ?>
                                <option value='0' Selected>No</option>
                                <option value='1'>Yes</option>
                            <?php } ?>
                        </Select>
                    </td>
                    <td></td>
                </tr>
                <tr>
                    <td colspan='2' style='text-align: right; color:black;'>Automatic Updates : </td>
                    <td style='text-align: left' ;>
                        <Select name='AutoUpdates' onchange="flagchanged(name);">
                            <?php if ($AutoUpdates == 1) { ?>
                                <option value='0'>No</option>
                                <option value='1' Selected>Yes</option>
                            <?php } else { ?>
                                <option value='0' Selected>No</option>
                                <option value='1'>Yes</option>
                            <?php } ?>
                        </Select>
                    </td>
                    <td></td>
                </tr>
                <?php
                if ($AutoUpdates == 0) { ?>
                    <tr>
                        <td colspan='2' style='text-align: right; color:black;'>Manual Update : </td>
                        <td <button style='text-align: center;font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:20px; width:40px; color: black; background-color: #C0C0C0;'>
                            <a href='systemupdate.php'>Update</a></button>
                        </td>
                        <td></td>
                    </tr>
                <?php } ?>

                <tr>
                    <td colspan='2' style='text-align: right; color:black;'>System Health : </td>
                    <td <button id="healthstatus" style='text-align: center;font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:20px; width:40px; color: black; background-color: <?php echo $healthstatus; ?>;'>
                        <a href='systemhealth.php'>Details</a></button>
                    </td>
                    <td></td>
                </tr>
                <tr>
                    <td></td>
                    <td colpan='2'><span style='color:#0033ff;'><span style='font-family:comic sans ms,cursive;'><span style='font-size:14px;'>
                                    <p></p>
                                </span></span></span></td>
                    <td></td>
                </tr>
                <tr>
                    <td style='text-align: center;'>
                        <input type='submit' name='submit' style='font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:90px; color: black; background-color:
                    <?php if ($reset == 1) {
                        echo "yellow";
                    } else {
                        echo "#C0C0C0";
                    } ?>;' value='Save'>

                    </td>
                    <td align="center">
                        <button style='text-align: center;font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:90px; color: black; background-color:  #C0C0C0;'>
                            <a href='setupdetails.php?reset'>Reset Form</a></button>
                    </td>
                    <td align="center">
                        <button style='text-align: center;font-size:14px; border-radius:14px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:90px; color: black; background-color: #C0C0C0;'>
                            <a href='setupdetails.php?reboot'>Reboot</a></button>

                    </td>
                    <td>
                        <button style='text-align: center;font-size:14px; border-radius:15px;-moz-border-radius:15px;-webkit-border-radius:15px; height:40px; width:90px; color: black; background-color: #C0C0C0;'>
                            <a href='setupdetails.php?shutdown'>Shutdown</a></button>
                    </td>
                </tr>
            </form>
        </table>
    </td>
</tr>
<?php include 'footer.php'; ?>