<?php
// Directory where the uploaded files will be saved
$target_dir = "uploads/";

// Ensure the uploads directory exists and is writable
if (!is_dir($target_dir)) {
    mkdir($target_dir, 0777, true);
}

// Flag to check if the upload is successful
$uploadOk = 1;
$statuscode = 1;
$update = 0;
if (isset($_GET["update"])) $update =  $_GET["update"];
//
// Pull Updates automatically or from User
if ($update == 1){
        // Download update from server
        $fileUrl = "http://downloads.jemrf.com:5678/smartgateway/jemrf-gw-current.deb";

    // Path where you want to save the downloaded file
    $target_file = $target_dir . "jemrf-gw-current.deb";

    // Fetch the file content from the URL
    $fileContent = file_get_contents($fileUrl);

    if ($fileContent === FALSE) {
        $statuscode = "Failed to download the Updates.";
        $uploadOk = 0;
    } else {
        // Save the file content to the local path
        $result = file_put_contents($target_file, $fileContent);
        if ($result === FALSE) {
            $statuscode =  "Failed to save the file.";
            $uploadOk = 0;
        }
    }
    if ($uploadOk == 0) {
        header("Location: systemupdate.php?failed=$statuscode");
        die();
    }
} else {
    // Path of the file to be uploaded
    $target_file = $target_dir . basename($_FILES["updatefile"]["name"]);

    // Check if the file provided
    if (strlen($target_file) < 9) {
        echo "Sorry, file Name Required.";
        $uploadOk = 0;
        $statuscode = "Sorry, No Update File Provided.";
    }

    // Check if Out of Band Patch
    // is file name patch.gz
    $outofband = 0;
    if ($target_file == $target_dir.'spatch.zip'){
        echo "Applying System Patch<br />";
        $outofband = 1;

    }else{
        // Check File type
        if (strpos($target_file, "zip")){
            echo "Sorry, Bad File.";
            $uploadOk = 0;
            $statuscode = "Sorry, bad file name.";
        }
        // Check if the file already exists
        if (file_exists($target_file)) {
            echo "Sorry, file already exists.";
            $uploadOk = 0;
            $statuscode = "Sorry, file already exists.";
        }
    }

    // Get the file type
    $imageFileType = strtolower(pathinfo($target_file, PATHINFO_EXTENSION));

    // Check the file size (limit to 5MB)
    if ($_FILES["updatefile"]["size"] > 5000000) {
        echo "Sorry, your file is too large.";
        $uploadOk = 0;
        $statuscode =  "Sorry, your file is too large.";
    }

    // Allow certain file formats (optional, adjust as needed)
    // Example: allow only certain image file formats
    $allowed_types = ["deb","zip"];
    if (!in_array($imageFileType, $allowed_types)) {
        echo "Sorry, only deb or zip files are allowed.";
        $uploadOk = 0;
        $statuscode =  "Sorry, only .deb or .zip files are allowed.";
    }

    // Check if $uploadOk is set to 0 by an error
    if ($uploadOk == 0) {
    header("Location: systemupdate.php?failed=$statuscode");
    } else {
        // Attempt to move the uploaded file to the target directory
        if (move_uploaded_file($_FILES["updatefile"]["tmp_name"], $target_file))
        {
            echo "The file " . htmlspecialchars(basename($_FILES["updatefile"]["name"])) . " has been uploaded.";
        } else {
            echo "Sorry, there was an error uploading your file.";
            $statuscode = "Sorry, there was an error uploading your file.";
            header("Location: systemupdate.php?failed=$statuscode");
        }
    }
}
//  Files uploaded build install command
if ($outofband == 0){
    $updatecommand = "sudo apt install /var/www/html/".$target_file . " --allow-downgrades -y";
}else{
    $updatecommand = "mv /var/www/html/".$target_file." /home/pi/gw2/script/ &&/home/pi/gw2/script/patch.sh";
}
//die($updatecommand);
$file = fopen("update_cmd.txt", "w");
fwrite($file, $updatecommand);
fclose($file);
if ($uploadOk ==1){
    header("Location: setupdetails.php?updating=1");
}

